package com.wudsn.productions.atari800.aspongy;


public final class ASpongyInteger extends ASpongy {

    private static final int BASE_SHIFT = 14;
    private static final int BASE = 1 << BASE_SHIFT;

    // private static final int BASE_SQRT = 128;
    // private static final int BASE_SQRT_SHIFT = BASE_SHIFT / 2;

    private int cos16(float a) {
	return (int) (Math.cos(a) * BASE);
    }

    private int mult16(int a, int b) {
	// long temp = (a >> BASE_SQRT_SHIFT) * (b >> BASE_SQRT_SHIFT);
	long temp = (a * b) >> BASE_SHIFT;
	return (int) temp;
    }

    @Override
    public void frame(float a, float b, int t, int[] imageData) {

	int acos, asin;
	int bcos, bsin;

	acos = cos16(a);
	asin = cos16(a + 8);

	bcos = cos16(b);
	bsin = cos16(b + 8);

	int imageIndex = 0;

	int XS, YS, ZS;
	XS = (const64 << BASE_SHIFT) + 9 * cos16(a + b);
	YS = (const64 << BASE_SHIFT) + 9 * cos16(b - a);
	ZS = (t & 127) << BASE_SHIFT; // Move through

	// println("t=" + t + " XS=" + XS / BASE + " YS=" + YS / BASE + " ZS="
	// + ZS / BASE);

	int ybsin = -bsin; // y=-1;ybsin = y*bsin
	int ybcos = -bcos; // y=-1;ybcos= y*bcos


	// println("ybsin=" + (ybsin * 1.0d) / BASE + " ybcos=" + (ybcos *
	// 1.0d)/ BASE);
	for (int y = 0; y < YSIZE; y++) {
	    int h = 0;

	    int u0, u, v, w;
	    u0 = -acos + asin;
	    w = acos + asin;

	    // println("u0=" + (u0 * 1.0d) / BASE + " w=" + (w * 1.0d) / BASE);

	    for (int x = 0; x < XSIZE; x++, imageData[imageIndex++] = h << 1) {
		v = ybcos - mult16(u0, bsin);
		u = mult16(u0, bcos) + ybsin;

		h = B127;

		int X, Y, Z;
		X = XS;
		Y = YS;
		Z = ZS;

		int m = 1;
		while (h > 0 && m < const64) {
		    int XM, YM, ZM;
		    XM = X;
		    YM = Y;
		    ZM = Z;

		    for (int i = 1; i < 5; i++) {
			int sum;
			sum = N[(XM >> BASE_SHIFT) & B127]
				+ N[(YM >> BASE_SHIFT) & B127]
				+ N[(ZM >> BASE_SHIFT) & B127];

			if (sum >= 2) {
			    break;
			}
			m = mfactors[i];
			XM = X * m;
			YM = Y * m;
			ZM = Z * m;

		    }
		    X += u;
		    Y += v;
		    Z += w;
		    h--;
		}

		u0 = u0 + (2*acos) / XSIZE;
		w = w - (2*asin) / XSIZE;
	    }

	    ybsin = ybsin + (2*bsin) / YSIZE;
	    ybcos = ybcos + (2*bcos) / YSIZE;
	}

    }
}
