;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Created 2010-09-19/2010-12-06 for the Sillyventure 2012 in Gdansk.
;
;	Ideas: S Dark Water like Thomson (CHR mode)
;	Raster, Horizontal Sine Rasters, Horizontal Twister (2 colors per twister)
;	Fractals, Split
;	TODO: Metaballs, Animate plasma

;	Sizes with debug_mode and fast_mode turned off 
;	2012-10-28:	14.348 => 2036 bytes free
;	2012-11-08:	14.917 => 1467 bytes free
;	2012-11-09:	14.772 => 1612 bytes free
;	2012-11-10:	14.960 => 1424 bytes free (final Diso Text engine and content)
;	2012-11-11:	14.939 => 1424 bytes free (final Diso Text engine and content)
;	2012-11-18:	15.241 => 1143 bytes free (plasmas)
;	2012-11-19:	15.816 =>  568 bytes free
;	2012-11-20	15.790 =>  594 bytes free (debug_mode removed)
;	2012-11-20	13.833 => 2551 bytes free (three_girls disabled)
;	2012-11-20	13.814 => 2551 bytes free (three_girls disabled)
;	2012-11-28	14.773 => 1656 bytes free (frame done, all bugs fixed)
;	2012-12-01	16.245 =>  139 bytes free (kickhand added)
;	2012-12-02	15.934 =>  450 bytes free (disco charset reduced to actually used characters)
;	2012-12-03	16.154 =>  230 bytes free (shades added)
;	2012-12-05	16.308 =>   76 bytes free (shades completed, text phase 7 added, wait_sound_position_added)
;	2012-12-06	16.381 =>    3 bytes free (original party version)
;	2012-12-18	16.381 =>    3 bytes free (original party version, plus fast mix version)

;.def split_mode	;Removed
;.def ntsc_mode		;Set by command line
;.def three_girls_mode	;Set by command line
;.def debug_mode	;Set by command line
;.def fast_mode		;Set by command line
;.def alignment_mode	;Should be set by default
;.def fast_mix		;Set by command line

cnt		= $14
sound_zp	= $20	;12 bytes

p1		= $40	;Common usage
p2		= $42
p3		= $44
p4		= $46
p5		= $48
p6		= $4a

x1		= $50	;Common usage
x2		= $51
x3		= $52
x4		= $53
x5		= $54
x6		= $55

cut_zp		= $58	;17 bytes

effect_zp	= $80	;No touched by main loop

; Gobal TIP screen constants.
tip_lines	= 100
tip_frame_size	= 40*tip_lines

tip_priorbit	= $01
tip_prior09	= $40+tip_priorbit
tip_prior10	= $80+tip_priorbit
tip_prior11	= $c0+tip_priorbit


;tip_split_reg	= $d01e		;Use $d01e to disable split
;tip_prior_split = $0a		;Not used
tip_black8	= 8		;Color 8 is also black with with low prio

; Cut mask constants
mask_sm_width		= 13
mask_sm_lines		= 25
mask_sm_size		= mask_sm_lines*mask_sm_width
mask_pm_lines		= tip_lines
mask_dmactl		= $22	;$22 without PM DMA, $2e with PM DMA
mask_hposp1		= $30	;Left gray border
mask_hposm1		= $d0	;Right gray border

effects_base		= $6900	;Up to $b5ff
cip_code_max		= $b5ff	;Used in debug_mode
cip_rasters_base	= $b400	;$200 bytes, not used when buffer is used

tip_base		= $b600
tip_maskp0tab		= tip_base+$000						;tip_lines bytes
tip_maskm0tab		= tip_base+$000+tip_lines				;tip_lines bytes
cip_charbuffer		= tip_base+$000+tip_lines*2				;2*8 bytes
cip_mosaic_data	 	= tip_base+$0d8						;$828 bytes
cip_charsettab0		= tip_base+$900						;cip_sm_lines bytes
cip_charsetchr0		= tip_base+$900+cip_sm_lines				;cip_sm_lines bytes
cip_charsettab1		= tip_base+$900+cip_sm_lines+cip_sm_lines		;tip_lines bytes
cip_charsettab2		= tip_base+$900+cip_sm_lines+cip_sm_lines+tip_lines	;tip_lines bytes
;cip_base_end		= tip_base+$9fa						;at $bffa

tip_dl1			= $d800	;to $da5x, graphics 9/10
tip_dl2			= $dc00	;to $de5x, graphics 10/9
tip_pixel_width		= 80
tip_sm_width		= 40
tip_sm_offset_lo	= $db00
tip_sm_offset_hi	= $df00
tip_sm09		= $c000	;to $cf40
tip_sm10		= $e000	;to $ef40
tip_sm11		= $f000	;to $ff40


cip_chr_offset		= 4	;1 charset equals 4 pages, $c000-$cfff, up to 4 charsets, $d800-$fbff, up to 8 charsets plus empty charset
cip_sm_width		= 40
cip_sm_lines		= 25
cip_charset_offset	= $0000	;64*8 bytes reserved for effects
cip_charset_c0		= $c000	;$1000 bytes, charsets at $c0/c4, $c8/cc
cip_charset_c4		= $c400
cip_charset_d8		= $d800	;$2000 bytes, charsets at $d8/dc, $e0/e4, $e8/ec, $f0/f4
cip_charset_dc		= $dc00
cip_charset_empty 	= $f000	;$f0/$f4
cip_sm_sta_lo		= $f000	;STA sm, low addresses
cip_sm_sta_hi		= $f400	;STA sm, hi addresses
cip_free_f8		= $f800	;$400 bytes currently free
cip_sm			= $fc00	;to $fee8


	opt h-l+r-	;Not using R+ is better when using Exomizer!

	icl "RGBA-Kernel-Equates.asm"

;===============================================================

;	Manually created COM file header
	rgba_load = $2000

	.byte $ff,$ff,a(rgba_load),a(rgba_load+rgba_len+[.len relocator]-1)

;===============================================================

	org $600
rgba_start
	jmp relocator+rgba_delta

;===============================================================

	.proc sinus		;Sinus tables
	sintab64_256 = $200		;$200 bytes
	sintab48_256 = $400		;$100 bytes
	sintab48_83 = $500		;$100 bytes

	sintab48_len = 83		;Prime number

	.proc reduce_sintab48_index	;IN: <A>=0...255, OUT: <A>=0..sintab48_length-1
more	cmp #sintab48_len
	bcc less
	sbc #sintab48_len
	bne more
less	rts
	.endp

	.endp

;===============================================================

	icl "RGBA-Kernel.asm"
	icl "snd/RGBA-Sound.asm"
	icl "seq/RGBA-Sequencer.asm"
	.if .not .def fast_mix
	icl "seq/RGBA-Sequencer-Operations.asm"
	.else
	icl "seq/RGBA-Sequencer-Operations-FastMix.asm"
	.endif

	
	.proc system
	.proc init
	sei
	jsr sync.vcount
	lda #$fe
	sta portb
	mwa #nmi.handler $fffa
	mva #$c0 nmien

	.if .def debug_mode
	mwa #irq $fffe
	.endif
	rts
	.endp

;===============================================================

	.proc irq
	.if .def debug_mode
	lda sound.position
	ldx sound.pointer
	.byte 2
	.endif
	.endp

;===============================================================
;	Externally used vectors

	vbiv = nmi.vbi.jump_vbi+1
	dliv = nmi.handler.jump_dli+1

	.proc set_vbiv
	jsr sync.cnt
	stx vbiv
	sty vbiv+1
	jmp sync.cnt
	.endp

	.proc nmi

	.proc handler
	bit nmist
	bpl vbi
jump_dli
	jmp dli
	.endp

	.proc dli
	rti
	.endp

	.proc vbi
	sta nmist
	pha
	txa
	pha
	tya
	pha

jump_vbi
	jsr empty_procedure

	jsr sound.play
	inc cnt
	pla
	tay
	pla
	tax
	pla
	rti
	.endp	;End of vbi

	.endp	;End of nmi

	.endp	;End of system

;===============================================================

	icl "RGBA-Main-Screen.asm"
	icl "RGBA-Disco.asm"

;===============================================================

	icl "RGBA-Cut.asm"

;===============================================================

	icl "tip/RGBA-TIP-Screen.asm"
	icl "cip/RGBA-CIP-Screen.asm"

;===============================================================

	.proc effects

	icl "cip/RGBA-CIP-Effects.asm"
	icl "tip/RGBA-TIP-Effects.asm"
	icl "kick/RGBA-KickHand.asm"
	.endp

	m_assert_end_of_code effects_base	;End of code which is used in main part

	icl "RGBA-Story.asm"
	icl "cip/RGBA-CIP-Mosaic-Pattern-Loader.asm"

;===============================================================

	.proc init_sintabs		;Initialize sintab64_256 and sintab48
	ldx #0
	ldy #64
loop64	lda sintab64_template,x
	sta sinus.sintab64_256,x
	sta sinus.sintab64_256+$40,y
	eor #$ff
	adc #128
	sta sinus.sintab64_256+$80,x
	sta sinus.sintab64_256+$c0,y
	inx
	dey
	bpl loop64

	ldx #0
	stx x1
loop256	lda sinus.sintab64_256,x
	pha
	asl			;<C>=0
	adc sinus.sintab64_256,x;*3
	ror			;/4
	lsr
	lsr
	sta sinus.sintab48_256,x

sta_adr	sta sinus.sintab48_83
	mva #opcode.lda_abs sta_adr
	clc
	lda x1
	adc #sinus.sintab48_len
	sta x1
	bcc no_inc
	inc sta_adr+1
	mva #opcode.sta_abs sta_adr
no_inc
	pla
	lsr
	sta sinus.sintab64_256,x
	sta sinus.sintab64_256+$100,x

	inx
	bne loop256
	rts

sintab64_template
	.byte sin(64,63,256,0,64)

	.endp


rgba_end
rgba_len = rgba_end-rgba_start
rgba_delta = rgba_load-rgba_start
;===============================================================

	.proc relocator
	ldy #>[rgba_len+255]-1
	ldx #0
loop
lda_adr	lda rgba_load,x
sta_adr	sta rgba_start,x
	inx
	bne loop
	inc lda_adr+2+rgba_delta
	inc sta_adr+2+rgba_delta
	dey
	bpl loop
	sty portb	;<Y>=$ff, Disable BASIC
	stx irqen	;<X>=$00, Disable regular keys and BREAK key
	lda #3
	sta skctl	;Reset registers if 1st POKEY after loading
	lda #3		;Packer optimization
	sta skctl+$10	;Reset registers of 2nd POKEY after loading
	lda #2		;Reset descruncher value
	sta chact	;Shadow register 
	sta chactl	;Hardware register
	sta coldst	;Force cold start
	jmp sequencer
	.endp

;===============================================================
	.print "SOUND.POSITION: ", sound.position
	.print "SOUND.POINTER: ", sound.pointer
