;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Raster bars effect.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

;===============================================================
	.proc rasters

;	Constants
	max_bars	= 15
	max_locked_bars = 7

	bar_height	= 16

	y_direction_up	= 0
	y_direction_down= 1

	y_offset_min	= 0
	y_offset_max	= $7f

	y_count_max	= $3f

	sinus_offset1	= 6
	sinus_offset2	= 5

	.enum bar_state
	stopped = 0
	sinus = 1
	locking = 2
	locked = 3
	unlocking = 4
	moving = 5
	.ende

;	Zeropage state variables
sinus_cnt1 = effect_zp
sinus_cnt2 = effect_zp+1

;	Global state variables
bar_colors	= cip_rasters_base		;$100 bytes + $20 bytes buffer
bar_curve	= cip_rasters_base+$120		;$100 by written, first $40 bytes used
bar_states	= cip_rasters_base+$160		;max_bars bytes used
bar_y_positions	= cip_rasters_base+$170		;max_bars bytes used
bar_counters	= cip_rasters_base+$180		;max_bars bytes used
bar_delays	= cip_rasters_base+$190		;max_bars bytes used
bar_end		= cip_rasters_base+$1a0

;	Local state variables
	.var y_direction = y_direction_up .byte
	.var y_offset    = y_offset_max .byte
 
;===============================================================

	.proc init

	m_init_squares init_squares_callback 5

	m_fill_memory bar_colors $100 $00
	mwa #execute sequencer.call_adr

	ldx #<generate_sm_code
	ldy #>generate_sm_code
	jmp init_sm_code

	.proc init_squares_callback	;IN: <X>=index
	cpx #y_count_max+1
	bcs skip
	lda init_squares.shifted_value
	sta bar_curve,x
skip	rts
	.endp

	.proc generate_sm_code
	bcs no_store	
	ldx ycount
	lda cip_charsetchr0,x
	sta (sm_ptr),y
no_store

	ldx xcount
	cpx #8
	bcs no_line
	lda ora1tab,x		;Self modifying code to determine of and which line is to be shifted
	sta ora1+1
	eor #cip_chr_offset
	sta ora2+1
	lda lsr1tab,x
	sta lsr1+1
	
	lda #$ad		;LDA bar_colors+offset
	jsr store_code_a
	lda ycount
	asl
	asl
	asl
	adc xcount
	adc #2*bar_height
	pha
	jsr store_code_a
	lda #>bar_colors
	jsr store_code_a

	lda #$8c		;STY bar_colors+offset
	jsr store_code_a
	pla
	jsr store_code_a
	lda #>bar_colors
	jsr store_code_a

	jsr generate_chr_sta	;STA charset_xy+offset

ora1	ora #$00
	jsr store_code_a

lsr1	lda #$00		;LSR
	beq no_lsr
	jsr store_code_a
	jsr store_code
	.byte 4, opcode.bne,$02,opcode.lda_imm,tip_black8*$11	;SNE, LDA #tip_black8*$11
no_lsr
	jsr generate_chr_sta
ora2	ora #$00
	jsr store_code_a	;STA charset_xy+offset
no_line
	sec			;Do not generate STA code
	rts
	
	.local ora1tab
	.byte $00,$00,$00,$04,$00,$00,$00,$04
	.endl
	.local lsr1tab
	.byte $00,$4a,$00,$4a,$00,$4a,$00,$4a
	.endl


	.proc generate_chr_sta	;OUT: <A>=high byte for STA
	offset = [cip_screen.cut_max_char-1]*8
	ldx ycount
	lda #$8d
	jsr store_code_a
	lda cip_charsetchr0,x
	asl
	asl
	asl
	ora xcount
	jsr store_code_a
	lda cip_charsettab0,x
	ora #>offset
	rts
	.endp

	.endp

	.endp

;===============================================================

	.proc init_bar_state

	.proc sinus
bottom_up
	lda #execute.print.bar_direction.bottom_up
	.byte $2c
top_down
	lda #execute.print.bar_direction.top_down
	sta execute.print.bar_direction_opcode

	ldx #max_bars-1
loop	lda #bar_state.sinus
	sta bar_states,x
	lda #0
	sta bar_delays,x
	sta sinus_cnt1
	sta sinus_cnt2
	dex
	bpl loop
	rts
	.endp
	
	.proc locking
	ldx #max_bars-1
loop	lda #bar_state.locking
	cpx #max_locked_bars
	bcc is_lockable
	lda #bar_state.stopped
is_lockable
	sta bar_states,x
	lda #y_offset_max
	sta bar_y_positions,x
	lda #y_count_max
	sta bar_counters,x
	txa
	eor #max_locked_bars
	asl
	asl
	asl
	asl
	sta bar_delays,x
	dex
	bpl loop
	rts
	.endp

	.proc unlocking
	ldx #max_locked_bars-1
loop	lda #bar_state.unlocking
	sta bar_states,x
	txa
	asl
	asl
	asl
	asl
	sta bar_delays,x
	dex
	bpl loop
	rts
	.endp


	.endp

;===============================================================

	.proc execute

	max_locked_bars = 7

	sinus_cnt1_tmp = x1
	sinus_cnt2_tmp = x2
	y_pos = x3

	.proc animate

	lda sinus_cnt1
	sta sinus_cnt1_tmp
	lda sinus_cnt2
	jsr sinus.reduce_sintab48_index
	sta sinus_cnt2
	sta sinus_cnt2_tmp

	ldx #max_bars-1
	lda #(max_bars-1)*bar_height+bar_height
	sta y_pos

loop	ldy bar_delays,x
	beq no_delay
	dec bar_delays,x
	jmp next

no_delay
	lda bar_states,x
	beq stopped
	cmp #bar_state.locked
	beq locked
	cmp #bar_state.sinus
	bne not_sinus
	clc
	ldy sinus_cnt1_tmp
	lda sinus.sintab64_256,y
	ldy sinus_cnt2_tmp
	adc sinus.sintab48_83,y
	sta bar_y_positions,x
	jmp next

not_sinus
	ldy bar_counters,x
	cmp #bar_state.locking
	bne not_locking
	dec bar_counters,x
	bne no_y_min
	inc bar_states,x
no_y_min
	jmp store_curve

not_locking
	cmp #bar_state.unlocking
	bne not_unlocking
	inc bar_counters,x
	cpy #y_count_max-1
	bcc no_y_max
	inc bar_states,x
no_y_max
;	jmp store_curve

store_curve
	lda bar_curve,y
	clc
	adc y_pos
	scc
	lda #y_offset_max
	sta bar_y_positions,x
	jmp next

ignore
	lda #bar_state.stopped
	sta bar_states,x
;	jmp next

not_unlocking
stopped
locked
next	clc
	lda sinus_cnt1_tmp
	adc #sinus_offset1
	sta sinus_cnt1_tmp
	clc
	lda sinus_cnt2_tmp
	adc #sinus_offset2
	jsr sinus.reduce_sintab48_index
	sta sinus_cnt2_tmp

	sec
	lda y_pos
	sbc #16
	sta y_pos

	dex
	bpl loop
	
	inc sinus_cnt1
	inc sinus_cnt1
	inc sinus_cnt2
;	rts			;Fall through
	.endp

;===============================================================

	.proc print
	.enum bar_direction
	bottom_up = $18
	top_down = $38
	.ende

	bar_color_and_tmp = x1
	bar_color_eor_tmp = x2

bar_color_and = *+1		;Set to "$nn"
	lda #$00
	sta bar_color_and_tmp
bar_color_eor = *+1		;Set to "$nn"
	lda #$00
	sta bar_color_eor_tmp

	ldx #max_bars-1
print_loop
	lda bar_y_positions,x
	adc y_offset
	bcs no_print		;y_overflow
	asl
	bcs no_print		;y_overflow
bar_direction_opcode		;Set to CLC=$18 or to SEC=$38
	clc
	bcc from_bottom
	sta subtractor+1
	lda #y_offset_max*2-2
subtractor
	sbc #00
from_bottom
	tay

	lda bar_original_colors,x
	and bar_color_and_tmp
	eor bar_color_eor_tmp

	jsr print_bar
no_print
	lda bar_color_and_tmp
	jsr swap_nibble
	sta bar_color_and_tmp
	lda bar_color_eor_tmp
	jsr swap_nibble
	sta bar_color_eor_tmp

	dex
	bpl print_loop

	ldy #$00		;Clear color
	jsr cip_code

	lda y_direction
	bne is_down
	lda y_offset
	beq is_done
	dec y_offset
	rts

is_down	lda y_offset
	cmp #y_offset_max
	bcs is_done
	inc y_offset
is_done	rts

	.proc swap_nibble	;IN: <X>=zp address
	asl
	adc #0
	asl
	adc #0
	asl
	adc #0
	asl
	adc #0
	rts
	.endp

	.local bar_original_colors
	.byte $33,$22,$11,$ff,$ee,$dd,$cc,$bb,$aa,$99,$88,$77,$66,$55,$44
	.endl


	.proc print_bar			;<A>=color, <Y>=y offset
	base_line = bar_colors+2

	sta base_line+$00,y
	sta base_line+$02,y
	sta base_line+$04,y
	sta base_line+$06,y
	sta base_line+$08,y
	sta base_line+$0a,y
	sta base_line+$0c,y
	sta base_line+$0e,y
	sta base_line+$10,y
	sta base_line+$12,y
	sta base_line+$14,y
	sta base_line+$16,y
	sta base_line+$18,y
	sta base_line+$1a,y
	sta base_line+$1c,y
	sta base_line+$1e,y

	lda #$ee
	sta base_line+$0f,y
	sta base_line+$11,y
	lda #$cc
	sta base_line+$0d,y
	sta base_line+$13,y
	lda #$88
	sta base_line+$09,y
	sta base_line+$17,y
	lda #$66
	sta base_line+$07,y
	sta base_line+$19,y
	lda #$44
	sta base_line+$05,y
	sta base_line+$1b,y
	lda #$22
	sta base_line+$03,y
	sta base_line+$1d,y
	lda #$00
	sta base_line+$01,y
	sta base_line+$1f,y
	lda #$aa
	sta base_line+$0b,y
	sta base_line+$15,y
	rts
	.endp
	.endp
	
	.endp		;End of execute
	
	.endp		;End of rasters
