;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Fire effect.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

	.proc rotator

rotator_zp	= effect_zp

	.proc init


	.proc circle
	jsr init_chr_code_callbacks.circle
	ldx #<init_sm_code_callback.circle
	ldy #>init_sm_code_callback.circle
	jmp init_sm_code
	.endp

	.proc bars
	jsr init_chr_code_callbacks.rainbow
	ldx #<init_sm_code_callback.bars
	ldy #>init_sm_code_callback.bars
	jmp init_sm_code
	.endp

	.proc twirl
	jsr init_chr_code_callbacks.circle
	ldx #<init_sm_code_callback.twirl
	ldy #>init_sm_code_callback.twirl
	jmp init_sm_code
	.endp

	.proc spiral
	jsr init_chr_code_callbacks.rainbow
	ldx #<init_sm_code_callback.spiral
	ldy #>init_sm_code_callback.spiral
	jmp init_sm_code
	.endp

 ;===============================================================

	.proc init_sm_code_callback	;IN: <Y>=0; OUT: <Y>=0
	xtmp = x5
	ytmp = x6

store	ldy #0
	ora #rotator_zp
	tax
	lda #opcode.lda_zp
	jsr store_code_ax
	clc
skip	rts				;Generate STA code if mask is not set

;===============================================================

	.proc circle

	bcs skip
	jsr fill_circle
	jsr compute_lum_value
	jmp store

	.end		;End of circle

;===============================================================

	.proc bars
	bcs skip

	jsr fill_and_63
	jsr compute_mirror

	clc
	lda xtmp
opcode_adr = *
	adc ytmp
	adc color_shift,x
	jmp store

color_shift	.byte $00,$20,$30,$00
	.endp

;===============================================================

	.proc twirl
	bcs skip

	.byte opcode.lax_zp, sm_ptr
	asl
	jsr fill_circle
	jsr compute_deg_value
	jmp store

	.endp		;End of twirl

;===============================================================

	.proc spiral
	bcs skip

	jsr fill_and_63

	jsr compute_lum_value
	sta adc_adr
	jsr compute_deg_value
	clc
adc_adr = *+1
	adc #0
	jmp store

	.endp	;End of twirl
;===============================================================

	.proc fill_circle
	.byte opcode.lax_zp, sm_ptr
with_ax	cpx #128
	bcs not_for_zp
	and #63
	cmp #32
	scc 
	eor #63
	cpx #64
	scc
	ora #$20
	sta rotator_zp,x
not_for_zp
	rts
	.endp

;===============================================================

	.proc fill_and_63
	.byte opcode.lax_zp, sm_ptr
	cmp #64
	bcs not_for_zp
	sta rotator_zp,x
	sta rotator_zp+64,x
not_for_zp
	rts
	.endp

	.proc compute_mirror	;IN: xcount, ycount OUT: xtmp, ytmp, <X>=quadrant 0..3
	ldx #0
	lda xcount
	cmp #21
	bcc not_right
	inx
not_right

	lda ycount
	cmp #13
	bcc not_bottom
	inx
	inx
not_bottom

	ldy xaddress,x
	lda $0000,y
	eor xsign,x
	clc
	adc xadd,x
	sta xtmp

	ldy yaddress-2,x
	lda $0000,y
	eor ysign,x
	clc
	adc yadd,x
	sta ytmp
	rts

xaddress	.byte xcount,ycount,ycount,xcount
yaddress	.byte /* ycount,xcount, */ xcount,ycount	;Overlap
xsign		.byte $00,$00,$ff,$ff
ysign		.byte $00,$ff,$00,$ff
xadd		.byte $00,$00,20,20
yadd		.byte $00,20,$00,20

	.endp	;End of compute_mirror

;===============================================================

	.proc compute_lum_value
	lda xcount
	cmp #21
	bcc not_right
	eor #$ff
	adc #40
not_right
	sta xtmp

	lda ycount
	cmp #13
	bcc not_bottom
	eor #$ff
	adc #24
not_bottom
	sta ytmp

	tax
	lda xtmp

	sec
	sbc #9
	bcc not_diagonal
	cmp ytmp
	bcc not_diagonal

	tax
	lda ytmp
	adc #8-1	;<C>=1
	bcc compute

not_diagonal
	lda xtmp

compute	clc
	adc lumindextab,x
	tax
	lda lumtab,x
	rts
	.endp		;End of compute_lum_value

;===============================================================

	.proc compute_deg_value
	ldx xcount
	ldy ycount
	cpy #13
	bcc no_mirror

	lda #39
	sec
	sbc xcount
	tax
	lda #24
	sec
	sbc ycount
	tay

	lda #32
	.byte $2c
no_mirror
	lda #0
	sta xtmp

	clc
	lda #<degtab
	adc cip_sm_offsets.lo,y
	sta lda_adr
	lda #>degtab
	adc cip_sm_offsets.hi,y
	sta lda_adr+1
lda_adr	= *+1
	lda $ffff,x
	adc xtmp
	rts
	.endp		;End of compute_deg_value

	.endp		;End of init_sm_code_callback

	.endp		;End of init

;===============================================================

	.proc execute
twice	jsr once
once	lda rotator_zp+$7f
	pha
	ldx #$7f
loop	lda rotator_zp-1,x
	sta rotator_zp,x
	dex
	bne loop
	pla
	sta rotator_zp
	jmp cip_code
	.endp


 ;===============================================================

	.local lumindextab ;13 bytes
	.byte 0,9,19,30,42,55,69,84,100,117,135,154,174
	.endl

	.local lumtab ;195 bytes
	.byte $3f,$3d,$3a,$38,$36,$34,$32,$30,$2e,$3e,$3b,$39,$37,$34,$32,$30,$2e,$2c,$2a,$3c,$3a
	.byte $38,$35,$33,$31,$2e,$2c,$2a,$28,$26,$3b,$39,$36,$34,$32,$2f,$2d,$2b,$28,$26,$24,$22
	.byte $3a,$38,$35,$33,$30,$2e,$2b,$29,$27,$25,$22,$20,$1e,$39,$37,$34,$32,$2f,$2d,$2a,$28
	.byte $25,$23,$21,$1f,$1c,$1a,$38,$36,$33,$31,$2e,$2c,$29,$27,$24,$22,$1f,$1d,$1b,$19,$17
	.byte $38,$35,$32,$30,$2d,$2b,$28,$25,$23,$20,$1e,$1c,$19,$17,$15,$13,$37,$34,$32,$2f,$2c
	.byte $2a,$27,$25,$22,$1f,$1d,$1a,$18,$15,$13,$11,$0f,$37,$34,$31,$2f,$2c,$29,$27,$24,$21
	.byte $1f,$1c,$19,$17,$14,$12,$0f,$0d,$0b,$36,$34,$31,$2e,$2b,$29,$26,$23,$21,$1e,$1b,$19
	.byte $16,$13,$11,$0e,$0c,$09,$07,$36,$33,$31,$2e,$2b,$28,$26,$23,$20,$1e,$1b,$18,$15,$13
	.byte $10,$0d,$0b,$08,$06,$03,$36,$33,$31,$2e,$2b,$28,$26,$23,$20,$1d,$1b,$18,$15,$13,$10
	.byte $0d,$0a,$08,$05,$02,$00
	.endl

	.local degtab ;520 bytes
	.byte $08,$08,$08,$09,$09,$09,$0a,$0a,$0a,$0b,$0b,$0b,$0c,$0c,$0d,$0d,$0e,$0e,$0f,$0f,$10,$10,$11,$11,$12,$12,$12,$13,$13,$14,$14,$15,$15,$15,$16,$16,$16,$17,$17,$17
	.byte $07,$08,$08,$08,$08,$09,$09,$09,$0a,$0a,$0b,$0b,$0c,$0c,$0d,$0d,$0e,$0e,$0f,$0f,$10,$10,$11,$11,$12,$12,$13,$13,$14,$14,$15,$15,$15,$16,$16,$16,$17,$17,$17,$18
	.byte $07,$07,$07,$08,$08,$08,$09,$09,$09,$0a,$0a,$0b,$0b,$0c,$0c,$0d,$0d,$0e,$0f,$0f,$10,$10,$11,$11,$12,$12,$13,$14,$14,$15,$15,$15,$16,$16,$17,$17,$17,$18,$18,$18
	.byte $06,$07,$07,$07,$07,$08,$08,$09,$09,$09,$0a,$0a,$0b,$0b,$0c,$0d,$0d,$0e,$0e,$0f,$10,$10,$11,$11,$12,$13,$13,$14,$14,$15,$15,$16,$16,$17,$17,$17,$18,$18,$18,$19
	.byte $06,$06,$06,$07,$07,$07,$08,$08,$08,$09,$09,$0a,$0a,$0b,$0c,$0c,$0d,$0e,$0e,$0f,$10,$10,$11,$12,$12,$13,$14,$14,$15,$15,$16,$16,$17,$17,$18,$18,$18,$19,$19,$19
	.byte $05,$05,$06,$06,$06,$07,$07,$07,$08,$08,$09,$09,$0a,$0a,$0b,$0c,$0c,$0d,$0e,$0f,$10,$10,$11,$12,$13,$14,$14,$15,$15,$16,$17,$17,$18,$18,$18,$19,$19,$19,$1a,$1a
	.byte $05,$05,$05,$05,$06,$06,$06,$07,$07,$07,$08,$08,$09,$0a,$0a,$0b,$0c,$0d,$0e,$0f,$10,$10,$11,$12,$13,$14,$15,$16,$16,$17,$17,$18,$18,$19,$19,$19,$1a,$1a,$1a,$1a
	.byte $04,$04,$04,$05,$05,$05,$05,$06,$06,$07,$07,$08,$08,$09,$0a,$0a,$0b,$0c,$0d,$0f,$10,$11,$12,$13,$14,$15,$16,$16,$17,$18,$18,$19,$19,$19,$1a,$1a,$1a,$1b,$1b,$1b
	.byte $03,$03,$04,$04,$04,$04,$05,$05,$05,$06,$06,$07,$07,$08,$09,$0a,$0b,$0c,$0d,$0e,$10,$11,$12,$14,$15,$16,$17,$17,$18,$19,$19,$1a,$1a,$1a,$1b,$1b,$1b,$1b,$1c,$1c
	.byte $03,$03,$03,$03,$03,$03,$04,$04,$04,$05,$05,$05,$06,$07,$07,$08,$09,$0b,$0c,$0e,$10,$11,$13,$15,$16,$17,$18,$19,$19,$1a,$1a,$1b,$1b,$1b,$1c,$1c,$1c,$1c,$1c,$1d
	.byte $02,$02,$02,$02,$02,$02,$03,$03,$03,$03,$04,$04,$04,$05,$06,$07,$08,$09,$0b,$0d,$10,$12,$14,$16,$18,$19,$1a,$1a,$1b,$1b,$1c,$1c,$1c,$1c,$1d,$1d,$1d,$1d,$1d,$1d
	.byte $01,$01,$01,$01,$01,$01,$01,$02,$02,$02,$02,$02,$03,$03,$04,$04,$05,$07,$09,$0c,$10,$14,$17,$19,$1a,$1b,$1c,$1c,$1d,$1d,$1d,$1d,$1d,$1e,$1e,$1e,$1e,$1e,$1e,$1e
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$01,$01,$01,$01,$01,$02,$02,$04,$07,$10,$19,$1c,$1d,$1d,$1e,$1e,$1e,$1e,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f
	.endl

	m_info lumindextab
	m_info lumtab
	m_info degtab

	.endp	;End of fire
	
	m_info rotator
	