
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Character interlace screen routine.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

	.proc cip_screen

	effect_max_char = 63
	cut_empty_char  = 64
	cut_start_char  = 65
	cut_max_char    = 127	;Some chars reserved for raster bars

;===============================================================

	.proc init
	jsr part1
	jmp part2

with_current_mask
	jsr fade.clear_charsets
	jsr fade.clear_sm

part2	ldx #<do_vbi
	ldy #>do_vbi
	jmp system.set_vbiv

	.proc part1
	jsr main_screen.init		;Temporary black screen
	jsr fade.clear_charsets
	jsr fade.clear_sm
	jmp main_screen.clear_mask_p0_m0
	.endp
	.endp


;===============================================================

	.proc do_vbi
	jsr main_screen.set_vbi_defaults

;	Set DLPTR, DMACTL, SYSTEM.DLIV, DLI.KERNELV
	lda cnt
	lsr
	lda #<cip_charsettab1
	ldx #tip_prior09
	ldy #tip_prior10
	bcc is_dl1
	lda #<cip_charsettab2
	ldx #tip_prior10
	ldy #tip_prior09
is_dl1	sta do_kernel.even_line_charset+1
	sta do_kernel.kernel_loop.even_line_charset+1
	sta do_kernel.kernel_loop.odd_line_charset+1
	stx do_kernel.kernel_loop.even_line+1
	sty do_kernel.kernel_loop.odd_line+1

	mwa #dl dlptr
	mva #mask_dmactl dmactl
	mwa #main_screen.dli_upper_border system.dliv
	mwa #do_kernel main_screen.dli_upper_border.kernelv
	rts
	.endp

;===============================================================

	.local dl
	.byte $70,$70,$60+$80,$00
	.byte $42,a(cip_sm)
:24	.byte $02
	.byte $41,a(dl)
	.endl
	m_assert_same_1k dl

;===============================================================

	.proc do_kernel
	ldx #0
	ldy #tip_prior11

even_line_charset
	lda cip_charsettab1	;Special line 0
	sta chbase
	lda tip_maskp0tab	;Prepare to save cycles ...
	sta wsync		;... after wsync ...
	stx colbk		;... to reset background color
	jmp kernel_loop.start	;Skip first wsync in loop

	.proc kernel_loop
even_line_charset
	lda cip_charsettab1,x
	sta wsync
	sta chbase
	lda tip_maskp0tab,x
start	sty prior

	sta hposp0
	lda tip_maskm0tab,x
	sta hposm0
	sta wsync
even_line
	lda #tip_prior10
	sta prior
	inx

odd_line_charset
	lda cip_charsettab1,x
	sta wsync
	sty prior
	sta chbase
	lda tip_maskp0tab,x
	sta hposp0
	lda tip_maskm0tab,x
	sta hposm0
	sta wsync

odd_line
	lda #tip_prior09
	sta prior
	inx
;	sta wsync
	cpx #tip_lines
	bne kernel_loop
	.endp

	m_assert_same_page kernel_loop
	jmp main_screen.show_lower_border.without_p1
	.endp		;End of do_kernel

;===============================================================

	.proc fade
in_chr_only
	lda #fade_lines_callback.fade_mode.set_chr_only
	ldx #$00
	beq in_mode
in_all	lda #fade_lines_callback.fade_mode.set_all
	ldx #$ff 
in_mode	sta fade_lines_callback.mode
	stx cut.cut_visible

	jsr cut.fill_buffer
	jsr clear_charsets
	jsr fill_sm
	mwa #fade_lines_callback main_screen.fade_lines.jsr_adr
	jmp main_screen.fade_lines

out	lda #fade_lines_callback.fade_mode.clear_all
	.byte $2c
out_girls
	lda #fade_lines_callback.fade_mode.clear_chr_only
	sta fade_lines_callback.mode
	ldx #>cip_charset_empty		;Make sure it is empty again
	jsr clear_charsets.clear_charset
	jsr main_screen.fade_lines
	jsr clear_sm
	jmp cut.next

;===============================================================
	.proc clear_charsets		;Clear all chars and fill char 0 of all charsets

	ldx #>cip_charset_c0+$00
	jsr clear_charset
	ldx #>cip_charset_c0+$08
	jsr clear_charset
	ldx #>cip_charset_d8+$00
	jsr clear_charset
	ldx #>cip_charset_d8+$08
	jsr clear_charset
	ldx #>cip_charset_d8+$10
	jsr clear_charset
	ldx #>cip_charset_d8+$18
	jsr clear_charset
	rts

	.proc clear_charset		;IN: <X>=high byte

	stx adr0+2			;Set pointers
	inx
	stx adr1+2
	inx
	stx adr2+2
	inx
	stx adr3+2
	inx
	stx adr4+2
	inx
	stx adr5+2
	inx
	stx adr6+2
	inx
	stx adr7+2

	mva #0 fill_memory.value	;Clear with $00
	lda adr0+2			;Address high byte
	ldx #8				;Number of pages
	jsr fill_memory.fill_page_ax

	lda #tip_black8*$11		;Clear graphics 10 lines with tip_black8
	ldx #0
loop
adr0	sta cip_charset_empty+$003,x
adr1	sta cip_charset_empty+$103,x
adr2	sta cip_charset_empty+$203,x
adr3	sta cip_charset_empty+$303,x
adr4	sta cip_charset_empty+$401,x
adr5	sta cip_charset_empty+$501,x
adr6	sta cip_charset_empty+$601,x
adr7	sta cip_charset_empty+$701,x

	inx
	inx
	inx
	inx
	bne loop
	rts
	.endp	;End of clear_charset

	.endp	;End of clear_charsets

;===============================================================

	.proc clear_sm
	lda #cut_empty_char	;Not zero, that's why m_clear_memory is not used
	ldx #0
loop	sta cip_sm,x
	sta cip_sm+$100,x
	sta cip_sm+$200,x
	sta cip_sm+$300-24,x	;Prevent overwriting $fff8-$ffff
	inx
	bne loop
	rts
	.endp

;===============================================================

	.proc fill_sm

	ycount = x1
	xcount = x2
	charset_count = x3
	character_count = x4
	character_free = x5

	sm09_ptr = p1
	sm10_ptr = p2
	sm11_ptr = p3
	sm_ptr = p4
	charset_ptr1 = p5
	charset_ptr2 = p6

;	Source screens
	mwa cut.cut_sm09_ptr sm09_ptr
	mwa cut.cut_sm10_ptr sm10_ptr
	mwa cut.cut_sm11_ptr sm11_ptr

;	Target screen
	mva cut.cut_start sm_ptr
	mva #>cip_sm sm_ptr+1

	lda #0
	sta ycount
	sta charset_count
charset_loop
	lda #cut_start_char	;Start new charset 
	sta character_count
	lda #cut_max_char
	sta character_free
	lda #<[cut_start_char*8];Start offset, low byte
	sta charset_ptr1
	sta charset_ptr2

	ldx charset_count
	lda charset_pages,x
	.if .def debug_mode
overflow beq overflow		;Optimization
	.endif

	ora #>[cut_start_char*8];Start offset, high byte
	sta charset_ptr1+1
	ora #cip_chr_offset	;4 pages ahead
	sta charset_ptr2+1
y_loop	ldy ycount
	lda charset_ptr1+1	;Store high byte of charset pointer aligned to 1k boundary
	and #$fc
	sta cip_charsettab0,y
	lda character_free	;Store first free character for the line
	sta cip_charsetchr0,y

	jsr cut.count_mask	;Check if used characters will fit into charset limit
	tya
	clc
	adc character_count
	cmp character_free
	bcc no_new_charset	;Yes, stay in current charset
	inc charset_count	;No, start next charset
	bne charset_loop

no_new_charset
	mva #0 xcount
x_loop	jsr one_character
	inc xcount
	lda xcount
	cmp cut.cut_width
	bne x_loop
	asl
	adc xcount
	ldx #sm09_ptr
	jsr add_byte_to_pointer
	ldx #sm10_ptr
	jsr add_byte_to_pointer
	ldx #sm11_ptr
	jsr add_byte_to_pointer

	lda #cip_sm_width
	sec
	sbc cut.cut_width
	ldx #sm_ptr
	jsr add_byte_to_pointer

	dec character_free
	inc ycount
	lda ycount
	cmp #cip_sm_lines
	bne y_loop
	rts


	.proc one_character
	
	charbuffer.page1 = cip_charbuffer
	charbuffer.page2 = cip_charbuffer+8

	jsr char_to_charbuffer
	
	sec
	lda sm09_ptr
	sbc cut.cut_width4
	sta sm09_ptr
	scs
	dec sm09_ptr+1

	sec
	lda sm10_ptr
	sbc cut.cut_width4
	sta sm10_ptr
	scs
	dec sm10_ptr+1

	sec
	lda sm11_ptr
	sbc cut.cut_width4
	sta sm11_ptr
	scs
	dec sm11_ptr+1

	ldy ycount
	lda xcount
	clc
	adc cut.cut_start
	jsr cut.check_mask
	beq mask_not_set

	ldy #16			;Save characters if they are empty
	lda #0
check_empty
	ora charbuffer.page1-1,y
	dey
	bne check_empty
	cmp #0
	beq is_empty

	lda character_count
	sta (sm_ptr),y		;<Y>=0

	ldy #7
charbuffer_to_charset
	lda charbuffer.page1,y
	sta (charset_ptr1),y
	lda charbuffer.page2,y
	sta (charset_ptr2),y
	dey
	bpl charbuffer_to_charset
	inc character_count

	lda #8
	ldx #charset_ptr1
	jsr add_byte_to_pointer 
	ldx #charset_ptr2
	jsr add_byte_to_pointer
mask_not_set
is_empty
	inw sm_ptr
	rts

	.proc char_to_charbuffer
	ldy #0
	ldx #0
	jsr upper_lines
upper_lines
	lda (sm11_ptr),y	;Copy graphics 11
	sta charbuffer.page1,x
	sta charbuffer.page2,x
	lda (sm09_ptr),y	;Copy graphics 9
	sta charbuffer.page1+1,x
	lda (sm10_ptr),y	;Copy graphics 10
	sta charbuffer.page2+1,x
	jsr next_line

	lda (sm11_ptr),y	;Copy graphics 11
	sta charbuffer.page1,x
	sta charbuffer.page2,x
	lda (sm10_ptr),y	;Copy graphics 10
	sta charbuffer.page1+1,x
	lda (sm09_ptr),y	;Copy graphics 9
	sta charbuffer.page2+1,x

	.proc next_line
	stx savex+1
	lda cut.cut_width
	ldx #sm09_ptr
	jsr add_byte_to_pointer
	ldx #sm10_ptr
	jsr add_byte_to_pointer
	ldx #sm11_ptr
	jsr add_byte_to_pointer
savex	ldx #0
	inx
	inx
	rts
	.endp

	.endp
	.endp
	
	.local charset_pages
	.byte >[cip_charset_c0+$000],>[cip_charset_c0+$800],>[cip_charset_d8],>[cip_charset_d8+$800],>[cip_charset_d8+$1000]
	.if .def debug_mode
	.byte 0
	.endif
	.endl

	.endp

;===============================================================

	.proc fade_lines_callback	;IN: <A>=lines in [0..tip_lines-1]

	.enum fade_mode
	set_all		= $ff
	set_chr_only	= $00
	clear_chr_only	= $01
	clear_all	= $02
	.ende
	
	tay
	lsr
	lsr
	tax

mode	= *+1
	lda #fade_mode.set_all
	bmi set_all
	beq set_chr_only
	cmp #fade_mode.clear_chr_only
	beq clear_chr_only

	lda #mask_hposp1	;Cover P1 with P0 and M1 with M0
	sta tip_maskp0tab,y
	lda #mask_hposm1
	sta tip_maskm0tab,y
	lda #>cip_charset_empty
	sta cip_charsettab1,y
	ora #cip_chr_offset
	sta cip_charsettab2,y
	rts

clear_chr_only
	lda #0			;Remove P0 and M0
	sta tip_maskp0tab,y
	sta tip_maskm0tab,y
	lda #>cip_charset_empty
	sta cip_charsettab1,y
	ora #cip_chr_offset
	sta cip_charsettab2,y
	rts

set_chr_only
	lda cip_charsettab0,x
	sta cip_charsettab1,y
	ora #cip_chr_offset
	sta cip_charsettab2,y
	rts

set_all
	lda cip_charsettab0,x
	sta cip_charsettab1,y
	ora #cip_chr_offset
	sta cip_charsettab2,y
	lda (cut.cut_maskp0_ptr),y
	sta tip_maskp0tab,y
	lda (cut.cut_maskm0_ptr),y
	sta tip_maskm0tab,y
	rts
	.endp		;End of fade_lines_callback

	.end		;End of fade

	.endp		;End of cip_screen
