;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Amiga Kickstart screen end sequence with drive noise.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

kick_pm		= $8000
kick_sm		= $8800
kick_chr	= $8c00

disk_color	= $76

	.proc kickhand
	
	.proc init
	lda #0
	sta nmien
	sta dmactl
	tax
loop	sta antic,x
	sta gtia,x
	sta pokey,x
	inx
	bne loop

	sta fill_memory.value
	m_fill_memory kick_pm $1000
	m_copy_memory kick_font kick_chr, $400
	.endp

	.proc flash
	lda #15
	jsr wait.with_colbk
	lda #8
	jsr wait.with_colbk
	lda #15
	jsr wait.with_colbk
	.endp

	lda #3
	sta skctl	;Otherwise RANDOM will not work!
	lda #$3d
	sta dmactl
	mwa #kick_dl dlptr
	lda #>kick_chr
	sta chbase
	lda #>kick_pm
	sta pmbase

	.proc init_pm
	ldx #127
loop
	cpx #70
	bcs too_much
	lda #$fc
	sta kick_pm+$343,x
	cpx #.len kick_gtia
	bcs too_much
	lda kick_gtia,x
	sta gtia,x
	cpx #22
	bcs too_much
	lda kick_diskslot,x
	sta kick_pm+$43a,x		;P0 = disk slot
	cpx #18
	bcs too_much
	lda #$ff
	sta kick_pm+$53a,x
	sta kick_pm+$53a+5,x
	sta kick_pm+$550,x
	sta kick_pm+$73a,x
	sta kick_pm+$73a+6,x
	sta kick_pm+$751,x
	lda #$f8
	sta kick_pm+$65c,x

	cpx #2
	bcs too_much
	lda #$08	;Right upper corner
	sta kick_pm+$33d,x
	lda #$0c
	sta kick_pm+$33f,x
	lda #$2c
	sta kick_pm+$341,x
	lda #$ff
	sta kick_pm+$361,x
	lda #$df
	sta kick_pm+$561,x
	lda #$f0
	sta kick_pm+$66d,x
	asl			;=> $e0
	sta kick_pm+$66f,x
	asl			;=> $c0
	sta kick_pm+$671	;No required in loop but reduces size
	asl			;=> $80
	sta kick_pm+$672
too_much
	dex
	bpl loop
	.endp

	.proc copy_screen
	ldy #16
next_line
	ldx #15
next_byte
lda_adr	lda kick_screen,x
sta_adr	sta kick_sm+7,x
	dex
	bpl next_byte
	clc
	lda lda_adr+1
	adc #16
	sta lda_adr+1
	scc
	inc lda_adr+2
	clc
	lda sta_adr+1
	adc #32
	sta sta_adr+1
	scc
	inc sta_adr+2
	dey
	bne next_line
	.endp

	.proc drive
	jsr wait.without_colbk
	jsr wait.without_colbk

loop	lda sinus.sintab64_256,x
	sta wsync	
	sta consol
	dex
	bne loop
	beq drive
	.endp

	.proc wait
with_colbk
	sta colbk
without_colbk
	ldx #62
loop	jsr sync.vcount
	dex
	bne loop
	rts
	.endp

	.local kick_diskslot
	.byte $fe,$fe,$fe,$fe
	.byte $fa,$fa,$fa,$fa,$fa,$fa,$fa,$fa,$fa,$fa,$fa
	.byte $fe,$fe,$fe,$fe,$fe,$fe,$fe
	.endl

	.local kick_dl
	.byte $70,$70,$70,$70,$70,$70
	.byte $42, a(kick_sm)
:15	.byte $02
	.byte $41, a(kick_dl)
	.endl
	m_assert_same_1k kick_dl

	.local kick_gtia
	.byte $75	;$d000
	.byte $69	;$d001
	.byte $69	;$d002
	.byte $87	;$d003
	.byte $75	;$d004
	.byte $97	;$d005
	.byte $99	;$d006
	.byte $00	;$d007
	.byte $ff	;$d008
	.byte $ff	;$d009
	.byte $00	;$d00a
	.byte $55	;$d00b
	.byte $00	;$d00c
	.byte $00	;$d00d
	.byte $00	;$d00e
	.byte $00	;$d00f
	.byte $00	;$d010
	.byte $00	;$d011
	.byte $08	;$d012
	.byte disk_color;$d013
	.byte disk_color;$d014
	.byte disk_color;$d015
	.byte $00	;$d016
	.byte $00	;$d017
	.byte $0e	;$d018
	.byte $00	;$d019
	.byte $0e	;$d01a
	.byte $01	;$d01b
	.byte $00	;$d01c
	.byte $03	;$d01d
	.endl

	.local kick_font
	ins "kick/Kickhand-Mono-256x128.fnt",+0,$320
	.endl
	
	.local kick_screen
	ins "kick/Kickhand-Mono-256x128.scr-256"
	.endl

	.endp	;End of kickhand
	
	m_info kickhand
