;
;	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
;
;	Operation sequence for the sequencer fast-mix.
;
;	@com.wudsn.ide.asm.mainsourcefile=..\RGBA.asm

	.local operations

	.use sequencer
	.use effects.cip
	.use effects.tip

	disco_delay0 = $00
	disco_delay1 = $10
	disco_delay2 = $20
	disco_delay3 = $30

	raster_delay = 128
	raster_delay_locking = 170
	raster_delay_unlocking = 118

	.if .not .def fast_mode
	m_init story.main
	.endif

	m_init mosaic_pattern_loader.init	;Use time to pre-preprocess the data
 
	.if .not .def fast_mode
	m_init story.fade_out
	.endif
	
	m_init mosaic_pattern_loader.copy	;Copy from buffer to actual location

 	m_init system.init
	m_init init_sintabs

;===============================================================

	.if .not .def fast_mode

	.local disco_1		;R.G.B.A.

	m_init disco.init
	m_call disco.execute

;	"R G B A"
	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0

;	m_wait_row 3 waiting
;	m_wait_time disco_delay3
	m_wait_sound_position $14

	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0

;	"RASTERS GIRLS BEER ATARI"
;	m_wait_row 0 not_used
	m_wait_sound_position $16

	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0

;	m_wait_row 3 waiting
;	m_wait_time disco_delay3
	m_wait_sound_position $18

	m_animate_row 3 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 0 disco_delay0
;	m_wait_row 0 not_used
	m_wait_sound_position $1a

;	CODE JAC / SOUND 505
	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay3
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0
	m_wait_row 3 waiting
;	m_wait_time disco_delay3
	m_wait_sound_position $1c

	m_animate_row 2 disco_delay0
	m_animate_row 3 disco_delay1
	m_animate_row 0 disco_delay0
	m_animate_row 1 disco_delay0

;	m_wait_row 0 not_used
	m_wait_sound_position $1e

;	FONT OOZ / GIRLS DOOMSDAY
	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay3
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0

	m_wait_row 3 waiting
	m_wait_sound_position $20

	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0

	m_wait_row 3 not_used
	.endl

;===============================================================

	.local rasters_1	;Normal, black & white up and down

	m_init cip_screen.init.part1	;No VBI yet, so increase speed
	m_init cip_screen.fade.in_chr_only

	m_init rasters.init
	m_call empty_procedure		;Disabe temporarily

	m_init rasters.init_bar_state.sinus.bottom_up
	m_poke rasters.execute.print.bar_color_and $00
	m_poke rasters.y_direction rasters.y_direction_up

	m_call rasters.execute		;Enable rasters
	m_init cip_screen.init.part2	;Enable VBI

	m_wait_value rasters.y_offset rasters.y_offset_min

;	m_wait_time raster_delay
;	m_wait_sound_position $28

	m_poke rasters.y_direction rasters.y_direction_down
	m_wait_value rasters.y_offset rasters.y_offset_max
	
	m_init cip_screen.fade.out
	.endl

;===============================================================

	.local disco_2		;MORE COLORS! MORE GIRLS!

;	"MORE COLORS! MORE GIRLS!"
	m_init disco.init
	m_call disco.execute

	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay3
;	m_wait_sound_position $2c
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0

	m_wait_row 2 waiting
	m_wait_row 3 waiting
;	m_wait_sound_position $2a

	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0
	m_wait_row 3 not_used
	.endl

;===============================================================

	.local bars_1	;TIP vertical, horizontal, diagonal and square rasters
	m_init tip_screen.init

;	m_wait_sound_position $32
	m_init tip_screen.fade.in
	m_init bars.init

	m_wait_sound_position $2c
	m_init bars.execute.vertical

	m_wait_sound_position $2e
	m_init bars.execute.horizontal

	m_wait_sound_position $30
	m_init bars.execute.diagonal1

	m_wait_sound_position $34
	m_init bars.execute.square.part1
	m_wait_sound_position $36
	m_init bars.execute.square.part2

	m_wait_sound_position $38

	m_init tip_screen.fade.out
	.endl

;===============================================================

	.local disco_3		;STATIC RASTERS ARE TOO 1986?

;	"STATIC RASTERS ARE TOO 1986?"
	m_init disco.init
	m_call disco.execute

;	m_wait_sound_position $40
;	m_wait_value sound.pointer $30
	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay3
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0
	m_wait_row 3 waiting

;	m_wait_sound_position $04
	m_animate_row 1 disco_delay1
	m_animate_row 3 disco_delay0
	m_wait_row 1 not_used
	m_wait_row 3 not_used

;	"STATIC IMAGES ARE TOO 1994?"
	m_animate_row 1 disco_delay1
	m_animate_row 3 disco_delay1
	m_wait_row 3 waiting

;	m_wait_sound_position $08
	m_wait_value sound.pointer $00
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay1
	m_wait_row 3 not_used

;	"STATIC IS NEVER MORE!"
;	m_wait_sound_position $0a
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay1

	m_wait_row 3 waiting
	m_wait_value sound.pointer $20

	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0
	m_wait_row 3 not_used
	.endl

;===============================================================

	.local rasters_2	;Normal, colored up and down

	m_init cip_screen.init
;	m_wait_sound_position $42
	m_init cip_screen.fade.in_all
	m_init rasters.init

;	m_wait_sound_position $10
;	m_wait_value sound.pointer $20
	m_init rasters.init_bar_state.sinus.bottom_up
	m_poke rasters.execute.print.bar_color_and $ff
	m_poke rasters.y_direction rasters.y_direction_up
	m_wait_value rasters.y_offset rasters.y_offset_min
;	m_wait_sound_position $02
	m_poke rasters.y_direction rasters.y_direction_down
	m_wait_value rasters.y_offset rasters.y_offset_max

;	m_wait_value sound.pointer $20
	m_init rasters.init_bar_state.sinus.top_down
	m_poke rasters.execute.print.bar_color_and $f0
	m_poke rasters.execute.print.bar_color_eor $34
	m_poke rasters.y_direction rasters.y_direction_up
	m_wait_value rasters.y_offset rasters.y_offset_min
;	m_wait_sound_position $06
	m_poke rasters.y_direction rasters.y_direction_down
	m_wait_value rasters.y_offset rasters.y_offset_max

	m_init cip_screen.fade.out_girls
	m_init cip_screen.fade.in_all
	m_init rasters.init

;	m_wait_sound_position $1e
	m_init rasters.init_bar_state.sinus.top_down
	m_poke rasters.execute.print.bar_color_and $ff
	m_poke rasters.execute.print.bar_color_eor $00
	m_poke rasters.y_direction rasters.y_direction_up
	m_wait_value rasters.y_offset rasters.y_offset_min
;	m_wait_sound_position $20
	m_poke rasters.y_direction rasters.y_direction_down
	m_wait_value rasters.y_offset rasters.y_offset_max

	m_init rasters.init_bar_state.sinus.bottom_up
	m_poke rasters.execute.print.bar_color_and $f0
;	m_poke rasters.execute.print.bar_color_eor $00
	m_poke rasters.y_direction rasters.y_direction_up
	m_wait_value rasters.y_offset rasters.y_offset_min
;	m_wait_sound_position $24
	m_poke rasters.y_direction rasters.y_direction_down
	m_wait_value rasters.y_offset rasters.y_offset_max

	m_init cip_screen.fade.out
	.endl			;End of rasters_1
 
 ;===============================================================

 	.local disco_4	;THE ROOF IS ON FIRE
 	m_init disco.init
	m_call disco.execute

	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay1
	m_wait_row 3 waiting
;	m_wait_sound_position $2a
	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay1

	m_wait_row 3 not_used

 	.endl	;End of disco_4
   
    ;===============================================================
   
 	.local fire_1	;Fire fading and and out
	m_init cip_screen.init
	m_init cip_screen.fade.in_all

	m_init fire.init
	m_call fire.execute
	m_poke fire.execute.worm_color $00	;Fade worms in
	m_wait_value fire.execute.worm_color 63

	m_wait_sound_position $20		;Starts at $1c/$15
	
	m_poke fire.execute.worm_color $40	;Fade worms out
	m_wait_value fire.execute.worm_color 127
	m_wait_time 8
;	m_wait_sound_position $3a
	m_init cip_screen.fade.out
 	.endl

 ;===============================================================

 	.local disco_5	;TWO GRRLS
 	m_init disco.init
	m_call disco.execute

	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay1
	m_wait_row 3 waiting
	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0
	m_wait_row 3 not_used

 	.endl	;End of disco_5
 
 ;===============================================================
	
	.local plasma_1		;Plasma
	plasma_delay = 46

	.local plasma_1
	m_init cip_screen.init	;First Girl
	m_init cip_screen.fade.in_all
	m_init rasters.init

	; Rasters locking from bottom up
	m_poke rasters.execute.print.bar_color_and $ff
	m_poke rasters.execute.print.bar_color_eor $00
	m_poke rasters.execute.print.bar_direction_opcode rasters.execute.print.bar_direction.bottom_up

	m_poke rasters.y_direction rasters.y_direction_up
	m_poke rasters.y_offset rasters.y_offset_min
	m_init rasters.init_bar_state.locking
	m_wait_time raster_delay_locking

	m_init plasma.init

	m_poke init_chr_code_callbacks.shade.callback.chroma $3
	m_init init_chr_code_callbacks.shade

	m_init mosaic.init.fade_in
	m_wait_value mosaic.active $fe
	m_wait_time plasma_delay
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe

	m_poke init_chr_code_callbacks.shade.callback.chroma $c
	m_init init_chr_code_callbacks.shade

	m_init mosaic.init.fade_in
	m_wait_value mosaic.active $fe
	m_wait_time plasma_delay
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe

	m_poke init_chr_code_callbacks.shade.callback.chroma $7
	m_init init_chr_code_callbacks.shade
	m_init plasma.init

	m_init mosaic.init.fade_in
	m_wait_value mosaic.active $fe
	m_wait_time plasma_delay
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe

	m_init rasters.init
	m_init rasters.init_bar_state.unlocking
	m_wait_time raster_delay_unlocking
	m_init cip_screen.fade.out_girls
	.endl
	
	.local plasma_2
	m_init cip_screen.init.with_current_mask
	m_init cip_screen.fade.in_all
	m_init rasters.init

	; Rasters locking from top down
	m_poke rasters.execute.print.bar_color_and  $00
	m_poke rasters.execute.print.bar_direction_opcode rasters.execute.print.bar_direction.top_down
	m_init rasters.init_bar_state.locking
	m_wait_time raster_delay_locking

	m_init plasma.init
	m_init init_chr_code_callbacks.rainbow

	.rept 3
	m_init mosaic.init.fade_in
	m_wait_value mosaic.active $fe
	m_wait_time plasma_delay
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe
	.endr

	m_init rasters.init
	m_init rasters.init_bar_state.unlocking
	m_wait_time raster_delay_unlocking
	m_init cip_screen.fade.out
	.endl

	.endl		;End of plasma_1

;===============================================================

	.local disco_6	;HELLO
 	m_init disco.init
	m_call disco.execute

 ;	HELLO ....
	m_animate_row 0 disco_delay1
 
 	.local rept_0
 
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0
	m_wait_row 3 waiting

;	Sync
	m_wait_sound_position $16
	
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay1
	m_wait_row 3 not_used
	.endl

;===============================================================

	.local rept_1

;	Special handling for LA RESISTANCE
	m_animate_row 1 disco_delay1	;LA
	m_animate_row 2 disco_delay1	;RESISTANCE
	m_animate_row 3 disco_delay1
	m_wait_row 3 waiting

;	Change HELLO
	m_animate_row 0 disco_delay0
	m_wait_row 0 not_used
	m_animate_row 0 disco_delay0

;	Sync
	m_wait_sound_position $1a

;	Special handling for LA RESISTANCE
	m_animate_row 1 disco_delay1	;LA
	m_animate_row 2 disco_delay1	;RESISTANCE
	m_animate_row 3 disco_delay1
	m_wait_row 3 not_used
	.endl

;===============================================================

	.local rept_2
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay1
	m_wait_row 3 waiting

;	Sync
	m_wait_sound_position $1e

	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay1
	m_wait_row 3 not_used
	.endl

;===============================================================

	.local rept_3
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay1
	m_wait_row 3 waiting

;	Change HELLO
	m_animate_row 0 disco_delay0
	m_wait_row 0 not_used
	m_animate_row 0 disco_delay0

;	Sync
	m_wait_sound_position $22
	
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay1
	m_wait_row 3 not_used
	.endl

;===============================================================

	.local rept_4

	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay1
	m_wait_row 3 waiting

;	Sync
	m_wait_sound_position $26

;	Fade last HELLO
	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay1
	m_wait_row 3 not_used
	.endl

 	.endl		;End of disco_6

 ;===============================================================

  	.local overlay_1		;Circle overlays
	m_init cip_screen.init
	m_init cip_screen.fade.in_all

	; Rasters locking from top down
	m_init rasters.init
	m_poke rasters.execute.print.bar_color_and $ff
;	m_poke rasters.execute.print.bar_color_eor $00
	m_poke rasters.execute.print.bar_direction_opcode rasters.execute.print.bar_direction.top_down

	m_poke rasters.y_direction rasters.y_direction_up
	m_poke rasters.y_offset rasters.y_offset_min
	m_init rasters.init_bar_state.locking
	m_wait_time raster_delay_locking

	m_init overlay.init
	m_call overlay.execute
	
	.local stripes_1
	m_init overlay.init.init_stripes

	m_poke overlay.execute.speed1 0	;Default values
	m_poke overlay.execute.speed2 0
	m_init mosaic.init.fade_in
	m_wait_value mosaic.active $fe

;	m_wait_sound_position $0c
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe

	m_poke overlay.execute.speed1 3
	m_init mosaic.init.fade_in
	m_wait_value mosaic.active $fe
;	m_wait_sound_position $10
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe

	m_poke overlay.execute.speed2 2
	m_init mosaic.init.fade_in
	m_wait_value mosaic.active $fe
	m_wait_sound_position $3a
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe
	.endl

	.local circles_1
	m_init overlay.init.init_circles
	m_poke overlay.execute.cnt1 0	;Default values
	m_poke overlay.execute.cnt2 0
	m_poke overlay.execute.speed1 0
	m_poke overlay.execute.speed2 0
	m_init mosaic.init.fade_in
	m_wait_value mosaic.active $fe
;	m_wait_sound_position $42
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe

	m_poke overlay.execute.speed1 3
	m_init mosaic.init.fade_in
	m_wait_value mosaic.active $fe
	m_wait_sound_position $06
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe

	m_poke overlay.execute.speed2 2
	m_init mosaic.init.fade_in
	m_wait_value mosaic.active $fe
	m_wait_sound_position $0c
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe
	.endl

	m_init rasters.init
	m_init rasters.init_bar_state.unlocking
	m_wait_time raster_delay_unlocking

	m_init cip_screen.fade.out
 	.endl
 
  ;===============================================================

	.local disco_7			;SHADE BOOBS
 	m_init disco.init
	m_call disco.execute

;	m_wait_sound_position $30

;	SHADE BOOBS - I MEAN BOBS
	m_wait_value sound.pointer $38
	m_animate_row 0 disco_delay0
	m_animate_row 1 disco_delay3
	m_wait_row 1 waiting
	m_wait_value sound.pointer $38
	m_animate_row 2 disco_delay0
	m_animate_row 3 disco_delay3
	m_wait_row 3 waiting
;	m_wait_sound_position $36
	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0
	m_wait_row 2 not_used
	m_wait_row 3 not_used
	.endl

  ;===============================================================

	.local shades_1			;TIP shade boobs
	m_init tip_screen.init

	m_init tip_screen.fade.in
	m_init shades.init

;	m_wait_sound_position $16
	m_call shades.execute
	m_wait_sound_position $1a
	m_init shades.init.next
	m_wait_sound_position $1e
	m_init shades.init.next
	m_wait_sound_position $22
	m_wait_value sound.pointer $30
	m_init shades.init.next
	m_init tip_screen.fade.out
	.endl
 
   ;===============================================================
 
 	.local disco_8		;30 YEARS ATARI...
 	m_init disco.init
	m_call disco.execute

;	30 YEARS ATARI XL SO GRAB YOUR BEER
	m_wait_value sound.pointer $38
	m_animate_row 0 disco_delay0
	m_animate_row 1 disco_delay1
;	m_wait_row 1 waiting
	m_wait_value sound.pointer $38
	m_animate_row 2 disco_delay0
	m_animate_row 3 disco_delay1
;	m_wait_row 3 waiting
	m_wait_value sound.pointer $30
	m_animate_row 0 disco_delay1
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay0
	m_wait_row 3 not_used


;	ARE YOU READY? HERE COMES
;	m_wait_value sound.pointer $30
;	m_animate_row 0 disco_delay0
;	m_animate_row 1 disco_delay1
;	m_wait_value sound.pointer $30
;	m_animate_row 2 disco_delay0
;	m_animate_row 3 disco_delay1
;	m_wait_row 3 waiting
;	m_wait_value sound.pointer $30
;	m_animate_row 0 disco_delay0
;	m_animate_row 1 disco_delay0
;	m_animate_row 2 disco_delay0
;	m_animate_row 3 disco_delay0	
;	m_wait_row 3 not_used
;	
;	THE FINAL COUNT DOWN
;	m_wait_value sound.pointer $30
;	m_animate_row 0 disco_delay1
;	m_animate_row 1 disco_delay1
;	m_animate_row 2 disco_delay1
;	m_animate_row 3 disco_delay1
;	m_wait_row 3 waiting
;	m_wait_value sound.pointer $30
;	m_animate_row 0 disco_delay1
;	m_animate_row 1 disco_delay1
;	m_animate_row 2 disco_delay1
;	m_animate_row 3 disco_delay0
;	m_wait_row 3 not_used
	.endl				;End of disco_8

;===============================================================

 	.endif

	.local rotator_1		;Circles and twisters
	m_init cip_screen.init

	m_init cip_screen.fade.in_all

	; Rasters locking from bottom up
	m_init rasters.init
	m_poke rasters.execute.print.bar_color_and $00
;	m_poke rasters.execute.print.bar_color_eor $00
	m_poke rasters.execute.print.bar_direction_opcode rasters.execute.print.bar_direction.bottom_up

	m_poke rasters.y_direction rasters.y_direction_up
	m_poke rasters.y_offset rasters.y_offset_min
	m_init rasters.init_bar_state.locking
	m_wait_time raster_delay_locking

	m_init rotator.init.circle
	m_call rotator.execute.once
	
	m_init mosaic.init.fade_in	;Start
;	m_wait_value mosaic.active $fe

	m_wait_sound_position $32	;Starts at $30
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe

	m_init rotator.init.bars

	m_init mosaic.init.fade_in
;	m_wait_value mosaic.active $fe
	m_wait_sound_position $38
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe

	m_poke rotator.init.init_sm_code_callback.bars.opcode_adr opcode.eor_zp
	m_init rotator.init.bars

	m_init mosaic.init.fade_in
;	m_wait_value mosaic.active $fe
	m_wait_sound_position $3c
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe

	m_init rotator.init.twirl
	m_call rotator.execute.twice

	m_init mosaic.init.fade_in
;	m_wait_value mosaic.active $fe
	m_wait_sound_position $42	
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe

	m_init rotator.init.spiral
	m_call rotator.execute.once

	m_init mosaic.init.fade_in
;	m_wait_value mosaic.active $fe
	m_wait_sound_position $06
	m_init mosaic.init.fade_out
	m_wait_value mosaic.active $fe

	m_init rasters.init
	m_init rasters.init_bar_state.unlocking
	m_wait_time 112

	m_init cip_screen.fade.out
	m_poke sound.mpt_player.update_pokey.aud_adr sound.mpt_player.freq

	.endl

;===============================================================

	.local disco_9		;WARNING! 8 BIT LIMITS BROKEN!
 	m_init disco.init
	m_call disco.execute

;	WARNING! 8 BIT LIMITS BROKEN!
	m_wait_value sound.pointer $30
	m_animate_row 0 disco_delay1
	m_wait_value sound.pointer $10
	m_animate_row 1 disco_delay1
	m_animate_row 2 disco_delay1
	m_animate_row 3 disco_delay1
	m_wait_row 3 waiting
	m_wait_value sound.pointer $20
	m_animate_row 1 disco_delay0
	m_animate_row 2 disco_delay0
	m_animate_row 3 disco_delay0
	m_wait_row 2 not_used

;	REBOOT
;	m_wait_value sound.pointer $30
	m_animate_row 2 disco_delay1
	m_wait_row 2 waiting
	m_wait_value sound.pointer $30
 	.endl			;End of disco_9
  
  ;===============================================================
  
  	.local kickhand_1
	m_init effects.kickhand.init

	.if .def debug_mode
	.byte $ff
	.endif

	.endl
;===============================================================

	.endl	;End of operations

	m_info operations
