;
;	>>> Silly Things by JAC! <<<
;
;	Created 2010-10-10/2010-12-09 for the Sillyventure 2010 in Gdansk.
;	Use ".def fast_mix" to change the main part implementation.
;	If ".def fast_mix" is commented out, the identical original V1.2 released at Sillyventure will be generated
;	If ".def fast_mix" is not commented out, the remix with smoother animations and faster pace will be generated
;
;	All code by JAC!
;	Music by 505/Checkpoint.
;	Graphics by OOZ.
 
e3	= 1
.def use_nmi
;.def fast_mix	
;.def fast_mode
;.def show_time

; Constants
silly_prior	= $11

; Sound equates from compiling
mpt_sound_start		= $0200
mpt_player.init 	= $1365
mpt_player.play		= $137D
mpt_player.volume	= $1747
mpt_player.pozptr	= $13E6
mpt_player.pozsng	= $1409
mpt_sound_end		= $178c

; Main code
code_start		= $2000

; Zero page
dliup		= main_zp	;DLI counter.
flasher_zp	= main_zp+1	;3 bytes
;cnt		= main_zp+4	;Frame counter, same address $14 as OS
x1		= main_zp+5	;Must not be used in interrupts, only in linear code
p1		= main_zp+6	;Must not be used in interrupts, only in linear code
p2		= main_zp+8	;Must not be used in interrupts, only in linear code

	icl "Silly-Globals.asm"

;===============================================================
  
	opt l+

	org fader_start
	.local fader
	icl "fader/Silly-Fader.asm"
	.endl

	ini fader.init

;===============================================================

	org intro_start
	.local intro
	icl "intro/Silly-Intro.asm"
	.endl

	ini intro.init

;===============================================================

	org loader_start
	.local loader
	icl "loader/Silly-Loader.asm"
	.endl

	ini loader.init

;===============================================================
;	Permanent code which will be there until the end of the demo
	org code_start

	icl "Silly-Kernel-Equates.asm"
	icl "Silly-Kernel.asm"

;===============================================================


	.proc main

	.enum operation
	wait_time
	wait_value
	wait_call
	init
	mva
	mwa
	call
	jump
	.ende
	
	jsr field.points.init
	
	jsr sync.cnt
	mwa #field.dli silly_dli.dliv
	mwa #field.field_dl silly_dl.dlv
	mva #1 field.points.drawing
loop
	.if .def show_time
	ldx $d20a
	stx $d01a
	.endif
	lda cnt
	cmp #0			;Wait as long as the count is still the same
last_cnt = *-1
	beq loop
	sta last_cnt		;Store new count
	.if .def show_time
	lda #0
	sta $d01a
	.endif

	jsr header.effect.move
header_adr = *-2
	jsr effect.flasher.move
flasher_adr = *-2

	jsr fetch_operation
	jsr no_operation
call_adr = *-2
	jmp loop

;===============================================================

	.proc no_operation
	rts
	.endp

;===============================================================

	.proc fetch_operation
	jsr wait_time
wait_adr = *-2
	bne return

next_operation
	jsr get_byte

	cmp #operation.wait_time
	bne no_wait_time
	jsr get_byte
	sta wait_time.counter
	jsr get_byte
	sta wait_time.counter+1
	mwa #wait_time wait_adr
return	rts

no_wait_time
	cmp #operation.wait_value
	bne no_wait_value
	jsr get_byte
rr	sta wait_value.value
	jsr get_byte
	sta wait_value.value_adr
	jsr get_byte
	sta wait_value.value_adr+1
	mwa #wait_value wait_adr
	rts

no_wait_value
	cmp #operation.wait_call
	bne no_wait_call
	jsr get_byte
	sta wait_adr
	jsr get_byte
	sta wait_adr+1
	rts

no_wait_call
	cmp #operation.init
	bne no_init
	jsr get_byte
	sta init_adr
	jsr get_byte
	sta init_adr+1
	jsr $ffff
init_adr = *-2
	jmp next_operation

no_init	cmp #operation.mva
	bne no_mva
	jsr get_byte
	tax
	jsr get_byte
	sta mva_adr
	jsr get_byte
	sta mva_adr+1
	stx $ffff
mva_adr = *-2
	jmp next_operation

no_mva	cmp #operation.mwa
	bne no_mwa
	jsr get_byte
	tax
	jsr get_byte
	tay
	jsr get_byte
	sta mwa_adr
	jsr get_byte
	sta mwa_adr+1
	txa
	jsr mwa_sub
	inw mwa_adr
	tya
	jsr mwa_sub
	jmp next_operation
mwa_sub
	sta $ffff
mwa_adr = *-2
	rts


no_mwa	cmp #operation.call
	bne no_call
	jsr get_byte
	sta call_adr
	jsr get_byte
	sta call_adr+1
	jmp next_operation

no_call
	cmp #operation.jump
	bne no_jump
	jsr get_byte
	tax
	jsr get_byte
	stx get_byte.adr
	sta get_byte.adr+1
	jmp next_operation

no_jump	jam

	.proc get_byte
	.if .def fast_mode
	lda split.operations
	.else
	lda field.operations
	.endif
adr = *-2
	inw adr
	rts
	.endp			;get_byte

	.endp			;fetch_operation

;===============================================================

	.proc wait_time		;Returns with Z=0 if counter has reached zero
	lda counter
	ora counter+1
	beq zero
	dew counter
	lda #1
zero	rts

counter	.word 0
	.endp

;===============================================================

	.proc wait_value	;Returns with Z=0 if value address has has reached value
	lda $ffff 
value_adr = *-2
	cmp #0
value	= *-1
	rts
	.endp
	
;===============================================================

	.proc wait_mpt		;Returns with Z=0 if the current pattern has a drum
	lda mpt_player.pozptr
	clc
	adc #9
	and #15
	rts
	.endp			;End of wait_mpt

;===============================================================

	.endp			;End of main

	.if .def fast_mix	;Alignment space for critical boundaries
	.ds 42
	.else
	.ds 49
	.endif

;===============================================================

	.proc nmi
	pha
	bit $d40f
	bpl vbi
	jmp dli_end		;DLI vector, return with JMP dli_end or PLA:RTI
dliv	= * -2

vbi	sta nmires
	mwa #silly_dl dlptr	;Force DL back in place
	lda #$22		;Normal playfield
	sta dmactl
	lda #$40+silly_prior
prior_adr = *-1
	sta prior
	lda #0			;Reset DLI counter
	sta dliup
	inc cnt			;Count frames.
	jmp vbi_end
vbiv	= *-2			;VBI vector, return with JMP vbi_end
vbi_end
	pla
	rti

main_dli
	txa
	pha
	tya
	pha

main_nmi_end
	bit mpt_player.play
	pla
	tay
	pla
	tax
dli_end	pla
	rti
	.endp
	
;===============================================================

	.local effect
	.proc flasher

new_color	= flasher_zp
count		= flasher_zp+1
color		= flasher_zp+2

	.proc init
	ldx #0
	stx color
	dex
	stx count
	rts
	.endp

	.proc move
	lda count
	bmi return
	cmp #16
	beq do_new_color
	cmp #48
	bne no_new_color
do_new_color
	mvx new_color color
no_new_color
	and #31
	cmp #16
	bcc less
	eor #31
less	tax
	ora color
	sta colpf3	;5th player/misible
	lda #14
white2 	ora color
	sta colpf2	;Color 3
	txa
	cmp #8
	bcs *+4
	lda #8
brightness1 = *-1
	ora color
	sta colpf1	;Color 2
	txa
	cmp #4
	bcs *+4
	lda #4
	ora color
	sta colpf0	;Color 1

	dec count
return	rts
	.endp		;End of move
	.endp		;End of flasher

	.endl		;End of effect

;===============================================================

	assert_same_1k silly_dl

	.local silly_dl
	.byte $70,$f0
	.byte $80+$40+$2f
header_lms
	.word header_sm
	.byte $80+$0f,+$80+$2f,$80+$0f,$80+$2f
	.byte $90
	.byte $01	;Jump
dlv	.word vbl
vbl	.byte $41
	.word silly_dl
	.endl

	.proc silly_dli
	inc dliup
	lda dliup
	cmp #1		;The first 6 DLIs are for the logo
	beq dli1
	cmp #2
	beq dli2
	cmp #3
	beq dli3_and_5
	cmp #4
	beq dli4
	cmp #5
	beq dli3_and_5
	cmp #6
	beq dli6

	jmp nmi.main_dli;The 7th DLI is for the main screen
dliv = *-2 

	.proc dli1
	sta $d40a
	lda #13		;Apply vscrol trick to stretch lines by factor 4
	sta vscrol
	lda #3
	sta vscrol
	lda #$ff
	sta grafm 
	lda #$82
	sta hposm3
	pla
	rti
	.endp

	.proc dli2
	sta $d40a	;Apply vscrol trick to strech lines by factor 4
	lda #13
	sta vscrol
	lda #3
	sta vscrol
	lda #$82
	sta grafm 
	lda #$80
	sta hposm3
	pla
	rti
	.endp
	
	.proc dli3_and_5
	lda #$8f
	sta grafm 
	sta $d40a	;Apply vscrol trick to strech lines by factor 4
	lda #13
	sta vscrol
	lda #3
	sta vscrol
	pla
	rti
	.endp

	.proc dli4
	lda #$84
	sta grafm 
	sta $d40a	;Apply vscrol trick to strech lines by factor 4
	lda #13
	sta vscrol
	lda #3
	sta vscrol
	pla
	rti
	.endp

	.proc dli6
	lda #0
	sta grafm
	pla
	rti
	.endp
	
	.endp

	intro.loading.bar.next

;===============================================================
;	The split is the last effect as it needs almost all memory
	.local split
	icl "split/Silly-Split.asm"
	.endl

	intro.loading.bar.next

;===============================================================
;	The inflater will be overwritten by the split
	.local inflater
	icl "Silly-Inflater.asm"
	.endl

	intro.loading.bar.next

;===============================================================
;	The inflater will be overwritten by the split
	.local header
	icl "header/Silly-Header.asm"
	icl "header/Silly-Header-Data.asm"
	.endl	

	intro.loading.bar.next

;===============================================================
;	The field will be overwritten by the split
	.local field
	icl "field/Silly-Field.asm"
	.endl
	
	intro.loading.bar.next

;===============================================================
;	This data will be overwritten by the split

	.local split_pictures_dfl_load
	ins "split/Silly-Split-Pictures.dat.dfl",+$0000,$0800
	intro.loading.bar.next
	ins "split/Silly-Split-Pictures.dat.dfl",+$0800,$0800
	intro.loading.bar.next
	ins "split/Silly-Split-Pictures.dat.dfl",+$1000,$0800
	intro.loading.bar.next
	ins "split/Silly-Split-Pictures.dat.dfl",+$1800
	intro.loading.bar.next

;	ins "split/Silly-Split-Test-Pictures-C.dat.dfl"
;	ins "split/Silly-Split-Test-Frame.dat.dfl"
	.endl

	.local split_imx_load	;$82 bytes
	.word 0,6,12,18,25,31,37,44,50,57,64,70,77,84,91,98,106,113,121,128,136,145,153,162,171,180,189,199,210,220,232,243,256,268,282,296,311,328,345,363,383,404,427,451,478,508,541,577,618,663,715,774,843,925,1022,1140,1286,1475,1725,2075,2599,3470,5210,10428, 10428*2
	.endl

	.local split_sinus_load
	ins "split/Silly-Split-Sinus256.sin"
	.endl

	.local split_end_dfl
	ins "end/Silly-End.pic.dfl"
	.endl
code_end


;===============================================================

	org init_start

	.local init

	.byte 'Silly - Sillyventure 2010 Intro by JAC! and 505. Preliminary version - 2010-11-02',0

start	lda #1				;Make sure that RESET performs a cold start
	sta coldst
	jsr intro.loading.bar.finish	;End loading screen

wait_header				;Syncronoize intro fast mode header with new header
	lda intro.header.effect.move.move_cnt
	bne wait_header
	mva intro.header.effect.map_cnt header.effect.map_cnt
	tay
	jsr header.effect.init_maps
	jsr header.effect.move_fully

	jsr init_system

	mwa #mpt_sound_start_dfl inflater.inputPointer 
	mwa #mpt_sound_start inflater.outputPointer 
	jsr inflater.inflate

	jsr mpt_player.init
	mva #$20 nmi.main_nmi_end

	mwa #$3f00 effect.flasher.new_color

	mwa #field_chr_dfl inflater.inputPointer 
	mwa #field.field_chr inflater.outputPointer 
	jsr inflater.inflate

	mwa #field_data_dfl inflater.inputPointer 
	mwa #field.field_data inflater.outputPointer 
	jsr inflater.inflate

	.if .not .def fast_mode
wait_song
	lda mpt_player.pozsng
	cmp #4
	bne wait_song
	jsr main.wait_mpt
	mwa #$3f30 effect.flasher.new_color

wait_fade
	lda effect.flasher.count
	bpl wait_fade
	.endif

	ldx #<nmi.vbi_end
	ldy #>nmi.vbi_end
	jsr set_vbiv
	
	jsr sync.cnt		;Preset cnt, hoping the flashing in "The End" will not appear
	mva #0 cnt
	jmp main

;===============================================================
	.proc init_system
	mwa #vbi nmi.vbiv
	mwa #silly_dli nmi.dliv

loop	lda vcount
	bne loop
	sta dliup

	sei
	lda #$fe
	sta portb
	mwa #nmi $fffa
	mwa #irq $fffe
	mva #$c0 nmien
	lda #0
	sta irqen
	cli

	mva #$30 hposm0		;Inital missle positions
	mva #$36 hposm1
	mva #$7a hposm2
	mva #$82 hposm3		;This one will be changed by the DLI
	mva #$ff sizem		;Maximum width

	jsr effect.flasher.init
	rts
	.endp			;End of screen_init

;===============================================================

	.proc vbi		;During initializtion
	txa
	pha
	tya
	pha
	jsr header.effect.move
	jsr effect.flasher.move
	pla
	tay
	pla
	tax
	jmp nmi.vbi_end
	.endp			;End of vbi

	.endl			;End of init

	.if init + .len init >$c000
	.error  "Error: init ends in ROM at ", init + .len init
	.endif

;===============================================================
;	Run main part
	run init.start

;===============================================================
;	Print memory layout
	.print " "
	.print "Silly.asm"
	info fader
	info intro
	info loader
	info init
	.print "SOUND : ", mpt_sound_start, " - ", mpt_sound_end-1, " (", mpt_sound_end-mpt_sound_start,")"
	info main
	info split
	info inflater
	info header
	info field
	info split_pictures_dfl_load

	.print "FREE: ", code_end, " - ", field.field_data - 1, " (", field.field_data - code_end,")"

