; Check if this is PAL system and has 64k. 
; If not wait for a key and cold start.


	.byte 0,13,10,155
	.byte 'SillyThings Demo by JAC!/Peter Dell, 505/Nils Feske and OOZ/Adam Powroznik.',0,13,10,155
	.byte 'Original version for SillyVenture 2010 on 2010-12-10/12 in Gdansk.',0,13,10,155
	.if .def fast_mix
	.byte 'This fast mix version was compiled on 2010-12-22 21:56:00.',0,13,10,155
	.else
	.byte 'This fixed version was compiled on 2010-12-22 21:56:00.',0,13,10,155
	.endif

	.proc init

cnt	= $14	
x1	= $80
x2	= $81

	jsr check
	cpy #0
	bne fail
	jsr fade
	lda #$ff
	sta $d301
	rts

	.proc check
	lda $d014
	and #2
	bne fail	;Not PAL
	sei
	sta $d40e	;<A>=0
	tay
	lda $d301
	pha
	lda #$fe	;Disable BASIC and OS ROM
	sta $d301

	ldx $a000	;Check if BASIC area is writeable
	inc $a000
	cpx $a000
	bne basic_writable
	iny		;No
basic_writable
	ldx $e000	;Check if OS ROM ares is writeable
	inc $e000
	cpx $e000
	bne os_writable
	iny		;No
os_writable

	pla
	sta $d301	;Restore old configuration
	lda #$40
	sta $d40e
	cli
	rts
	.endp

;===============================================================

	.proc fail
	lda #14
	sta 708
	mwa #dl $230

loop	lda $d40b
	clc
	adc 20
	sta $d40a
	sta $d01a
	lda $d20f
	and #12
	cmp #12
	beq loop
	jmp $e474

dl	.byte $70,$70,$70,$70,$70,$70,$70,$70,$70,$70,$70,$70
	.byte $46
	.word sm
	.byte $70,$06
	.byte $70,$06
	.byte $41
	.word dl

sm	.byte "REQUIRES PAL SYSTEM."
	.byte "  REQUIRES 64K RAM. "
	.byte "PRESS KEY TO REBOOT."
	.endp

;===============================================================

	.proc fade	;Fade out all 9 color registers
fade_loop
	ldy #0		;Assume all zero
	ldx #8
color_loop
	lda 704,x
	pha
	and #$f0
	sta fade_color
	pla
	and #15
	beq zero
	sec
	sbc #1
	ora #$00
fade_color = *-1
	tay		;At least one not zero

zero	sta 704,x
	dex
	bpl color_loop
	lda cnt
	clc
	adc #2
	.if .not .def fast_mode
wait	cmp cnt
	bne wait
	.endif
	cpy #0
	bne fade_loop
	rts
	.endp		;End of fade

	.endp		;End of init
	