;
;	>>> Silly Things by JAC! <<<
;
;	Created 2010-10-10/2010-12-09 for the Sillyventure 2010 in Gdansk.
;
;	(c) 1993-06-28 by JAC! Abgnger!!
;	(r) 1993-12-29 by JAC! Infooooormer!!
;	(r) 2010-11-16 by JAC! for Sillyventure 2010


; Constants
field_max_height	= $20		;Maximum height, equals black
field_lines		= 169		;Number of visible lines
field_chr_width		= 6		;Width of scroll characters in pixels

; Zero page
field_vars	= field_zp		;Procedure local variables
field_vars_end	= $5f			;Last allowed address for local variables
points_zp	= $60			;SM up, frame counters, ..
		.if .def fast_mix	;Achieve equal binary 
code_zp		= $75			;Clear and plot routines
		.else
code_zp		= $80			;Clear and plot routines
		.endif

; Main memory
field_data	= $7400			;32*2 pages with x an y positions = $4000 bytes
					;Two screens, 32 x 192 bytes = $1800 bytes
field_chr	= $b400			;64*8 = $200 bytes of scroll character set
;header_sm	= $b600			;Globally defined, do not touch
field_sm1	= $b800			;Screen 1, must start at $x800, only $1520 bytes used
field_lhi1	= field_sm1+$1520	;Line address screen 1, high byte, field_lines+1 bytes used
field_oldlo1	= field_sm1+$1600	;Pixel address screen 1, low byte, 256 bytes used
field_oldhi1	= field_sm1+$1700	;Pixel address screen 1, high byte, 256 bytes used


field_sm2	= $d800			;Screen 2, must start at $x800, only $1520 bytes used
field_lhi2	= field_sm2+$1520	;Line address screen 2, high byte, field_lines+1 bytes used
field_oldlo2	= field_sm2+$1600	;Pixel address screen 2, low byte, 256 bytes used
field_oldhi2	= field_sm2+$1700	;Pixel address screen 2, high byte, 256 bytes used

field_base	= $f000			;Heap_field_base.
field_ctab0	= field_base+$000	;Field color 0, all zeros, 256 bytes used
field_ctab1	= field_base+$100	;Field color 1, 4 pixels repeated, 256 bytes used
field_ctab2	= field_base+$200	;Field color 2, 4 pixels repeated, 256 bytes used
field_ctab3	= field_base+$300	;Field color 3, 4 pixels repeated, 256 bytes used
field_otab	= field_base+$400	;Field offset x bytes (x div 4), 256 bytes used
field_mirror	= field_base+$500	;3 pages containing the 3 mirror offsets, 256 bytes used
field_berg	= field_base+$800	;4 consecutive pages containing the original and the 3 mirror images, 4*256 bytes used
field_buffer	= field_base+$c00	;2 pages for effect specific buffers, 2*256 bytes used
field_llo	= field_base+$e00	;Line address low bytes, field_lines+1 bytes used
field_ctab_hi	= field_base+$eaa	;Color table (field_ctab0/1/2/3_highword), field_max_height+1 bytes used
field_dl	= field_base+$f00	;$b0 bytes of DL, this is page $ff00, beware not to overwrite $fffa-$ffff.
field_dl_lms1	= field_dl		;LMS instruction for upper screen part
field_dl_lms2	= field_dl+$42		;LMS instruction for lower screen part


;===============================================================

	.local operations
	
	.use main
	
	.if .def fast_mix
remix
;	Texture start
texture
	dta b(operation.mva), b(1), a(field.points.drawing)			;Start drawing

	dta b(operation.init),a(field.effect.texture.init)
	dta b(operation.mva),b(1),a(field.effect.texture.texture_number)	;Color 1 texture
	dta b(operation.init),a(field.effect.texture.init_texture)

	dta b(operation.wait_value),b(6),a(mpt_player.pozsng)			;Wait for 1st drum
	dta b(operation.wait_call),a(wait_mpt)

	dta b(operation.mva),b(1),a(field.effect.texture.waiting_mode)		;Enable waiting mode
	dta b(operation.call),a(field.effect.texture.move)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.mva),b(0),a(field.effect.texture.waiting_mode)		;Disable waiting mode

	dta b(operation.mva),b(2),a(field.effect.texture.texture_number)	;Color 2 texture
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($12),a(mpt_player.pozsng)			;Wait for begin of "boing"
	dta b(operation.mwa),a(+$5f30),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b(0),a(effect.flasher.count)		;Wait for end of flash

	dta b(operation.wait_value),b($14),a(mpt_player.pozsng)			;Wait for end of "boing"
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.wait_value),b($18),a(mpt_player.pozsng)			;Wait for sound

	dta b(operation.mva),b(3),a(field.effect.texture.texture_number)	;Color 3 texture
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($1c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)

	dta b(operation.mva),b(4),a(field.effect.texture.texture_number)	;Color 4 texture
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($20),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.mwa),a(+$1fc0),a(effect.flasher.new_color)		;Flash

authors
	dta b(operation.mva),b(5),a(field.effect.texture.texture_number)	;First real texture: Invader
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($24),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)

	dta b(operation.mva),b(6),a(field.effect.texture.texture_number)	;Second real texture: JAC
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($28),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)

	dta b(operation.mva),b(7),a(field.effect.texture.texture_number)	;Third real texture: 505
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($2c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)

	dta b(operation.mva),b(8),a(field.effect.texture.texture_number)	;Third real texture: OOZ
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($30),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)

	dta b(operation.mva),b(1),a(field.effect.texture.texture_number)	;Color 1 texture
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.call),a(no_operation)					;Disable texture move

	dta b(operation.wait_value),b($32),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mwa),a(+$1f60),a(effect.flasher.new_color)		;Flash

	dta b(operation.wait_value),b($34),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(0),a(field.points.frame_step)

;	Square start
square
	dta b(operation.init),a(field.effect.square.init)
	dta b(operation.call),a(field.effect.square.move)

	dta b(operation.mva),b(1),a(field.effect.square.degree_speed)
	dta b(operation.mva),b(1),a(field.effect.square.degree_step)
	dta b(operation.mva),b(3),a(field.effect.square.sinus_delay)
	dta b(operation.mva),b(-1),a(field.effect.square.sinus_step)		;Fade square up
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)

	dta b(operation.wait_value),b($38),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)

	dta b(operation.wait_value),b($3a),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)

	dta b(operation.wait_value),b($3c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)

	dta b(operation.wait_value),b($3e),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(1),a(field.effect.square.sinus_delay)
	dta b(operation.mva),b(1),a(field.effect.square.sinus_step)		;Fade square down
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)

	dta b(operation.mwa),a(+$1f80),a(effect.flasher.new_color)		;Flash
	dta b(operation.mva),b(1),a(field.effect.square.degree_speed)		;Fade square up
	dta b(operation.mva),b(2),a(field.effect.square.degree_step)
	dta b(operation.mva),b(-1),a(field.effect.square.sinus_step)
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)

	dta b(operation.wait_value),b($42),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)

	dta b(operation.mva),b(1),a(field.effect.square.sinus_step)		;Fade square down
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)

	dta b(operation.mwa),a(+$1f70),a(effect.flasher.new_color)		;Flash
	dta b(operation.mva),b(1),a(field.effect.square.degree_speed)
	dta b(operation.mva),b(3),a(field.effect.square.degree_step)
	dta b(operation.mva),b(-1),a(field.effect.square.sinus_step)		;Fade square up
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)

	dta b(operation.wait_value),b($46),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	
	dta b(operation.wait_value),b($48),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(1),a(field.effect.square.sinus_step)		;Fade square down
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)
	dta b(operation.mva),b(-3),a(field.effect.square.degree_step)

	dta b(operation.mwa),a(+$1f90),a(effect.flasher.new_color)		;Flash
	dta b(operation.mva),b(-1),a(field.effect.square.sinus_step)		;Fade square up
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)

	dta b(operation.wait_value),b($4a),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)

;	dta b(operation.wait_value),b($4c),a(mpt_player.pozsng)			;Wait for sound
;	dta b(operation.mva),b(+1),a(field.points.frame_step)

	dta b(operation.wait_value),b($4e),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
;	dta b(operation.mva),b(1),a(field.effect.square.sinus_delay)
	dta b(operation.mva),b(1),a(field.effect.square.sinus_step)		;Fade square down
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)

	dta b(operation.call),a(no_operation)					;Disable texture move

	dta b(operation.mwa),a(+$1ff0),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b($50),a(mpt_player.pozsng)			;Wait for sound

;	VU meter
vu_meter
	dta b(operation.init),a(field.effect.vumeter.init)
	dta b(operation.call),a(field.effect.vumeter.move)

	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.wait_value),b($54),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)
	dta b(operation.wait_value),b($56),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.wait_value),b($58),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)
	dta b(operation.wait_value),b($5a),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.wait_value),b($5c),a(mpt_player.pozsng)			;Wait for sound

	dta b(operation.init),a(field.effect.texture.init)
	dta b(operation.mva),b(1),a(field.effect.texture.texture_number)	;Fade to color 1 texture
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.call),a(field.effect.texture.move)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

;	Scroll
scroll
	dta b(operation.wait_value),b($5e),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mwa),a(+$1f30),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b(0),a(field.points.frame_number)		;Wait correct frame position
	dta b(operation.mva),b(0),a(field.points.frame_step)			;Stop rotation
	dta b(operation.mva),b($00),a(field.points.frame_up)			;Fixed rotation 180 deg

	dta b(operation.wait_value),b($60),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(field.effect.scroll.init)
	dta b(operation.call),a(field.effect.scroll.move)			;Start scroll, part 1, JAC presents...
	dta b(operation.wait_value),b(0),a(field.effect.scroll.scrolling)	;Wait for end of scroll
	
	dta b(operation.wait_value),b($64),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b($60),a(field.points.frame_up)			;Fixed rotation 180 deg
	dta b(operation.mva),b(1),a(field.effect.scroll.scrolling)		;Restart scroll, part 2, a demo for ...
	dta b(operation.wait_value),b(0),a(field.effect.scroll.scrolling)	;Wait for end of scroll

;	dta b(operation.wait_value),b($6c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.wait_value),b($68),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.mwa),a(+$1f20),a(effect.flasher.new_color)		;Flash
	dta b(operation.mva),b(1),a(field.effect.scroll.scrolling)		;Restart scroll, part 3, greeetings

	dta b(operation.wait_value),b($6c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)
	dta b(operation.wait_value),b($6e),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)


	dta b(operation.wait_value),b($70),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)
	dta b(operation.wait_value),b($72),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.wait_value),b($74),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)
;	dta b(operation.wait_value),b($78),a(mpt_player.pozsng)			;Wait for sound
;	dta b(operation.mva),b(-1),a(field.points.frame_step)
;	dta b(operation.wait_value),b($7c),a(mpt_player.pozsng)			;Wait for sound
;	dta b(operation.mva),b(+1),a(field.points.frame_step)

	dta b(operation.wait_value),b(0),a(field.effect.scroll.scrolling)	;Wait for end of scroll
;	dta b(operation.wait_value),b($78),a(mpt_player.pozsng)			;Wait for sound
;	dta b(operation.mva),b(+1),a(field.points.frame_step)
;	dta b(operation.wait_value),b($7a),a(mpt_player.pozsng)			;Wait for sound
;	dta b(operation.mva),b(-1),a(field.points.frame_step)
;;	dta b(operation.wait_value),b($14),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mwa),a(+$1f10),a(effect.flasher.new_color)		;Flash
;	dta b(operation.mva),b(-1),a(field.points.frame_step)
	dta b(operation.mva),b(1),a(field.effect.scroll.scrolling)		;Restart scroll, part 4, thanks ...

	dta b(operation.wait_value),b($78),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.wait_value),b($7a),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)
	dta b(operation.wait_value),b($7c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)

	dta b(operation.wait_value),b(0),a(field.effect.scroll.scrolling)	;Wait for end of scroll

;	Texture to black
	dta b(operation.init),a(field.effect.texture.init)
	dta b(operation.mva),b(0),a(field.effect.texture.texture_number)	;Fade to color 0 texture
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.call),a(field.effect.texture.move)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.mva), b(0), a(field.points.drawing)			;End drawing

	dta b(operation.jump), a(split.operations)				;Continue with next part

	.else									;End if remix

;===============================================================
original
;	Texture start
texture
	dta b(operation.mva), b(1), a(field.points.drawing)			;Start drawing

	dta b(operation.init),a(field.effect.texture.init)
	dta b(operation.mva),b(1),a(field.effect.texture.texture_number)	;Color 1 texture
	dta b(operation.init),a(field.effect.texture.init_texture)

	dta b(operation.wait_value),b(6),a(mpt_player.pozsng)			;Wait for 1st drum
	dta b(operation.wait_call),a(wait_mpt)

	dta b(operation.mva),b(1),a(field.effect.texture.waiting_mode)		;Enable waiting mode
	dta b(operation.call),a(field.effect.texture.move)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.mva),b(0),a(field.effect.texture.waiting_mode)		;Disable waiting mode

	dta b(operation.mva),b(2),a(field.effect.texture.texture_number)	;Color 2 texture
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($12),a(mpt_player.pozsng)			;Wait for begin of "boing"
	dta b(operation.mwa),a(+$5f30),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b(0),a(effect.flasher.count)		;Wait for end of flash

	dta b(operation.wait_value),b($14),a(mpt_player.pozsng)			;Wait for end of "boing"
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.wait_value),b($18),a(mpt_player.pozsng)			;Wait for sound

	dta b(operation.mva),b(3),a(field.effect.texture.texture_number)	;Color 3 texture
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($1c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)

	dta b(operation.mva),b(4),a(field.effect.texture.texture_number)	;Color 4 texture
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($20),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.mwa),a(+$1fc0),a(effect.flasher.new_color)		;Flash

authors
	dta b(operation.mva),b(5),a(field.effect.texture.texture_number)	;First real texture: Invader
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($24),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)

	dta b(operation.mva),b(6),a(field.effect.texture.texture_number)	;Second real texture: JAC
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($28),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)

	dta b(operation.mva),b(7),a(field.effect.texture.texture_number)	;Third real texture: 505
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($2c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)

	dta b(operation.mva),b(8),a(field.effect.texture.texture_number)	;Third real texture: OOZ
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.wait_value),b($30),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)

	dta b(operation.mva),b(1),a(field.effect.texture.texture_number)	;Color 1 texture
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.call),a(no_operation)					;Disable texture move

	dta b(operation.wait_value),b($32),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mwa),a(+$1f60),a(effect.flasher.new_color)		;Flash

	dta b(operation.wait_value),b($34),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(0),a(field.points.frame_step)

;	Square start
square
	dta b(operation.init),a(field.effect.square.init)
	dta b(operation.call),a(field.effect.square.move)

	dta b(operation.mva),b(1),a(field.effect.square.degree_speed)
	dta b(operation.mva),b(1),a(field.effect.square.degree_step)
	dta b(operation.mva),b(-1),a(field.effect.square.sinus_step)		;Fade square up
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)

	dta b(operation.wait_value),b($38),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)

	dta b(operation.wait_value),b($3c),a(mpt_player.pozsng)			;Wait for sound

	dta b(operation.mva),b(1),a(field.effect.square.sinus_step)		;Fade square down
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)


	dta b(operation.mwa),a(+$1f80),a(effect.flasher.new_color)		;Flash
	dta b(operation.mva),b(2),a(field.effect.square.degree_speed)		;Fade square up
	dta b(operation.mva),b(2),a(field.effect.square.degree_step)
	dta b(operation.mva),b(-1),a(field.effect.square.sinus_step)
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)

	dta b(operation.wait_value),b($40),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)

	dta b(operation.mva),b(1),a(field.effect.square.sinus_step)		;Fade square down
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)
	dta b(operation.mva),b(-1),a(field.points.frame_step)

	dta b(operation.mwa),a(+$1f70),a(effect.flasher.new_color)		;Flash
	dta b(operation.mva),b(1),a(field.effect.square.degree_speed)
	dta b(operation.mva),b(3),a(field.effect.square.degree_step)
	dta b(operation.mva),b(-1),a(field.effect.square.sinus_step)		;Fade square up
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)

	dta b(operation.wait_value),b($44),a(mpt_player.pozsng)			;Wait for sound

;	dta b(operation.wait_value),b($48),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	
	dta b(operation.wait_value),b($48),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(1),a(field.effect.square.sinus_step)		;Fade square down
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)
	dta b(operation.mva),b(-3),a(field.effect.square.degree_step)

	dta b(operation.mwa),a(+$1f90),a(effect.flasher.new_color)		;Flash
	dta b(operation.mva),b(-1),a(field.effect.square.sinus_step)		;Fade square up
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)

	dta b(operation.wait_value),b($4e),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(1),a(field.effect.square.sinus_step)		;Fade square down
	dta b(operation.wait_value),b(0),a(field.effect.square.sinus_step)

	dta b(operation.call),a(no_operation)					;Disable texture move

	dta b(operation.mwa),a(+$1ff0),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b($50),a(mpt_player.pozsng)			;Wait for sound

;	VU meter
vu_meter
	dta b(operation.init),a(field.effect.vumeter.init)
	dta b(operation.call),a(field.effect.vumeter.move)

	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.wait_value),b($54),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)
	dta b(operation.wait_value),b($56),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.wait_value),b($58),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)
	dta b(operation.wait_value),b($5a),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.wait_value),b($5c),a(mpt_player.pozsng)			;Wait for sound

	dta b(operation.init),a(field.effect.texture.init)
	dta b(operation.mva),b(1),a(field.effect.texture.texture_number)	;Fade to color 1 texture
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.call),a(field.effect.texture.move)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

;	Scroll
scroll
	dta b(operation.wait_value),b($5e),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mwa),a(+$1f30),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b(0),a(field.points.frame_number)		;Wait correct frame position
	dta b(operation.mva),b(0),a(field.points.frame_step)			;Stop rotation
	dta b(operation.mva),b($00),a(field.points.frame_up)			;Fixed rotation 180 deg

	dta b(operation.wait_value),b($60),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(field.effect.scroll.init)
	dta b(operation.call),a(field.effect.scroll.move)			;Start scroll, part 1
	dta b(operation.wait_value),b(0),a(field.effect.scroll.scrolling)	;Wait for end of scroll
	
	dta b(operation.mva),b($60),a(field.points.frame_up)			;Fixed rotation 180 deg
	dta b(operation.mva),b(1),a(field.effect.scroll.scrolling)		;Restart scroll, part 2
	dta b(operation.wait_value),b(0),a(field.effect.scroll.scrolling)	;Wait for end of scroll

	dta b(operation.wait_value),b($6c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.mwa),a(+$1f20),a(effect.flasher.new_color)		;Flash

	dta b(operation.mva),b(1),a(field.effect.scroll.scrolling)		;Restart scroll, part 3

	dta b(operation.wait_value),b($70),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)
	dta b(operation.wait_value),b($74),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.wait_value),b($78),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)
	dta b(operation.wait_value),b($7c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)

	dta b(operation.wait_value),b(0),a(field.effect.scroll.scrolling)	;Wait for end of scroll

	dta b(operation.wait_value),b($14),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mwa),a(+$1f10),a(effect.flasher.new_color)		;Flash

	dta b(operation.mva),b(-1),a(field.points.frame_step)
	dta b(operation.mva),b(1),a(field.effect.scroll.scrolling)		;Restart scroll, part 4

	dta b(operation.wait_value),b($18),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(+1),a(field.points.frame_step)
	dta b(operation.wait_value),b($1c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva),b(-1),a(field.points.frame_step)

	dta b(operation.wait_value),b(0),a(field.effect.scroll.scrolling)	;Wait for end of scroll

;	Texture to black
	dta b(operation.init),a(field.effect.texture.init)
	dta b(operation.mva),b(0),a(field.effect.texture.texture_number)	;Fade to color 0 texture
	dta b(operation.init),a(field.effect.texture.init_texture)
	dta b(operation.call),a(field.effect.texture.move)
	dta b(operation.wait_value),b(0),a(field.effect.texture.doing)

	dta b(operation.mva), b(0), a(field.points.drawing)			;End drawing

	dta b(operation.jump), a(split.operations)				;Continue with next part
	.endif									;End of original

	.endl

;===============================================================

;	General subroutine for effects
	.proc effect

	.ds 1			;TEST spacing
			

	.proc init
	ldx #<field_vars
	lda #0
clear_field_vars
	sta field_vars-[<field_vars],x
	inx
	cpx #<field_vars_end
	bne clear_field_vars
	clear_memory field_buffer $200
	rts
	.endp

;===============================================================

	.proc texture

texture_size = 32	;Size of packed texture
queue_size = 16		;Size of move queue

texture_number	= field_vars
texture_point	= texture_number+1
queuing		= texture_point+1
queue_entries	= queuing+1			;Current number of used queue entries
move_point	= queue_entries+1

queue_state	= field_vars+16			;Offset for readability in monitor only
queue_index	= queue_state+queue_size

doing		= queue_index+queue_size	;Contains queuing || moving
waiting		= doing+1			;Indicates that we are waiting for a slot, blocks until reset externally
waiting_mode	= waiting+1			;1 to enable waiting mode, 0 do disable

addtab		= field_buffer+$000	;1 page
buffer		= field_buffer+$100	;1 page

;===============================================================
; Initializes the texture to the start and clears the move queue.

	.proc init
	jsr effect.init
	
	ldx #0
	ldy #$ff
init_addtab
	lda #1
	cpx #16			;Higher speed if difference >16
	bcc *+4
	lda #2
	sta addtab+1,x		;Add 1
	eor #$ff
	clc
	adc #1
	sta addtab,y		;Subtract 1
	inx
	dey
	cpx #field_max_height
	bne init_addtab
	lda #0			;Equals
	sta addtab

	mva #points.plot.mask.four points.plot.plot_mask
	rts
	.endp

;===============================================================
;	Texture number 0 ts the completely empty texture
;	Texture number 1 to 4  is the complete single color texture
;	Texture numbers 5 to ... are normal textures

	.proc init_texture
	lda texture_number
	cmp #5
	bcs get_normal_texture
	tay
	lda heights,y		
	ldy #0		;Create filled texture for 0..4
fill_empty_texture
	sta buffer,y
	iny
	bne fill_empty_texture
	beq move_texture

get_normal_texture
	sec		;Convert texture_number to address
	sbc #5		;5 pseudo textures
	asl		;Multiply by 64
	asl
	asl
	asl
	asl
	asl
	clc
	adc #<[textures_packed]
	sta p1
	lda #>[textures_packed]
	adc #0
	sta p1+1

	ldx #0			;Convert textures to heights.
get_next_texture_byte
	ldy #0
	lda (p1),y
	sta x1
	inw p1
	jsr convert_8_bits
	bne get_next_texture_byte

move_texture
	ldy #0			;All points of one texture
	sty texture_point
	iny
	sty queuing		;Set queuing to 1
	sty doing
	rts

	.proc convert_8_bits
	jsr convert_4_bits
convert_4_bits
	jsr convert_2_bits
convert_2_bits
	lda #0
	asl x1
	rol
	asl x1
	rol
	tay
	lda heights+1,y		;Real texture do no have black pixels
	sta buffer,x
	inx
	rts

	.endp

heights	.byte field_max_height, field_max_height-1,20,11,0

textures_packed
	ins "field/Silly-Field-Textures.dat"

	intro.loading.bar.next

	.endp

;===============================================================
; Perform a move step for all points in the texture

	
	.proc move

	lda queuing		;Any points left to put into the queue
	ora queue_entries	;Any points left in the queue?
	sta doing
	beq next_time

	lda waiting		;Waiting for MPT drum?
	beq next_texture_point
	jsr main.wait_mpt
	bne next_time		;Yes
	mva #0 waiting		;No, stop waiting
	beq next_texture_point
next_time
	rts

next_texture_point
	lda queue_entries	;Current number of queue entrie
	cmp #queue_size
	beq no_slot

	ldy texture_point	;Current point
	lda buffer,y
	cmp field_berg,y
	beq not_req		;No move required

	ldx #queue_size-1	;Move required
next_slot
	lda queue_state,x	;Find an empty slot
	beq empty_slot		;Found
	dex
	bpl next_slot
	jam			;Must no happen

empty_slot
	inc queue_state,x	;Create a new queue entry
	lda texture_point
	sta queue_index,x
	and #15			;Last entry in row?
	cmp #15
	bne next_row
	lda waiting_mode	;Waiting for an empty slot
	sta waiting
next_row
	inc queue_entries

not_req	lda queuing
	beq already_done
	inc texture_point
	bne more_points
	lda #0
	sta queuing

more_points
already_done
no_slot
	ldx #queue_size-1	;Move active points in the queue
	stx move_point

	.local move_queue
	ldx move_point
	lda queue_state,x	;Queue entry used?
	beq next_entry
	lda queue_index,x	;Get queue entry index
	tax
	tay			;X=Y=A=point number
	lda buffer,x		;Get point height from texture
	sec
	sbc field_berg,x	;Calculate distance
	beq point_is_done
	tay
	lda field_berg,x
	clc
	adc addtab,y		;Add/Sub step rate

	sta field_berg,x	;Store original
	ldy field_mirror,x
	sta field_berg+$100,y	;Store mirror 1
	ldy field_mirror+$100,x
	sta field_berg+$200,y	;Store mirror 2
	ldy field_mirror+$200,x
	sta field_berg+$300,y	;Store mirror 3
	dec move_point		;Move next point in queue
	bpl move_queue
	rts

point_is_done
	ldx move_point
	sta queue_state,x	;Clear state, x=movepoint
	dec queue_entries	;Decrease number of queue entries
	
next_entry
	dec move_point		;Move next point in queue
	bpl move_queue
	rts
	.endl

	assert_same_page move_queue

	.endp
	.endp

;===============================================================
	.proc square

	square_size		= 11	;Number distinct circles
	sinus_size		= $0	;Not needed at the moment
	sinus_template_size	= 32;

	sinus_offset 	= field_vars		;Current sinus offset
	sinus_step	= sinus_offset+1	;Sinus offset step rate (-1/2 or +1/2)
	.if .def fast_mix
	sinus_delay	= sinus_step+1		;Delay counter for steps
	sinus_delay_cnt	= sinus_delay+1		;Delay counter for steps
	sinus		= sinus_delay_cnt+1		;Effective sinus tab
	.else
	sinus		= sinus_step+1		;Effective sinus tab
	.endif

	degrees		= sinus+sinus_template_size ;Effective degrees
	degree_speed	= degrees+square_size
	degree_step	= degree_speed + 1

	.if degree_step > field_vars_end
	.error "degree_step_mode > field_vars_end (", degree_step,, " > ",field_vars_end,")"
	.endif

	.proc init
	jsr effect.init
	mva #field_max_height-1 sinus_offset
	mva #points.plot.mask.one points.plot.plot_mask
	rts
	.endp

	.proc move
	lda sinus_step		;Any offset step to perform?
	beq move_no_sinus_step

	.if .def fast_mix	;Speed needs to be reduced in optimized remix mode
	dec sinus_delay_cnt	;Only every nth frame after speedup
move_skip =*-1
	bpl move_no_sinus_step
	lda sinus_delay
	sta sinus_delay_cnt
	.endif

	lda sinus_offset
	clc
	adc sinus_step
	sta sinus_offset	;Store new offset
	beq move_sinus_stop
	cmp #field_max_height-1
	bne move_no_sinus_step
move_sinus_stop
	lda #0			;Stop movement
	sta sinus_step

move_no_sinus_step
	ldx #sinus_template_size-1
move_sinus
	lda sinus_template,x
	clc
	adc sinus_offset
	cmp #field_max_height
	bcc *+4
	lda #field_max_height-1
	sta sinus,x
	dex
	bpl move_sinus

	ldx #square_size-1
	lda degrees,x
	clc
	adc degree_speed
move_degrees
	and #31
	sta degrees,x
	clc
	adc degree_step
	dex
	bpl move_degrees

nokey

	icl "field/Silly-Field-Square.asm"
	rts

set_pixel
	sta field_berg,x	;Store original
	ldy field_mirror,x
	sta field_berg,y	;Store mirror 1 in same page
	ldy field_mirror+$100,x
	sta field_berg,y	;Store mirror 2 in same page
	ldy field_mirror+$200,x
	sta field_berg,y	;Store mirror 3 in same page
	rts

;	.get "Sinus256.sin"
;	.rept 32
;	.put[#] = .get[#*8] / 8
;	.endr
;	.sav sinus_template_size

sinus_template
	.byte $0f,$13,$16,$18,$1b,$1d,$1e,$1f,$1f,$1f,$1e,$1d,$1b,$18,$16,$13
	.byte $0f,$0c,$09,$07,$04,$02,$01,$00,$00,$00,$01,$02,$04,$07,$09,$0c
	.endp	;move
	.endp	;square

;===============================================================
	.proc vumeter

	.enum offset
	v1=$11
	v2=$19
	v3=$91
	v4=$99
	.ende

	.proc init
	lda #field_max_height-1
	sta field_buffer+offset.v1
	sta field_buffer+offset.v2
	sta field_buffer+offset.v3
	sta field_buffer+offset.v4

	mva #points.plot.mask.four points.plot.plot_mask
	rts
	.endp

	.proc move
	
	.macro set_pixel
	sta field_berg+:1,x	;Store original
	ldy field_mirror+:1,x
	sta field_berg+$100,y	;Store mirror 1 in same page
	ldy field_mirror+:1+$100,x
	sta field_berg+$200,y	;Store mirror 2 in same page
	ldy field_mirror+:1+$200,x
	sta field_berg+$300,y	;Store mirror 3 in same page
	.endm
	
	.macro set_line
	.if :2 = 1
	set_pixel :1*$10+$00
	set_pixel :1*$10+$01
	.endif
	set_pixel :1*$10+$02
	set_pixel :1*$10+$03
	.if :2 = 1
	set_pixel :1*$10+$04
	set_pixel :1*$10+$05
	.endif
	.endm
	
	lda mpt_player.volume
	ldx #offset.v1
	jsr channel
	lda mpt_player.volume+1
	ldx #offset.v2
	jsr channel
	lda mpt_player.volume+2
	ldx #offset.v3
	jsr channel
	lda mpt_player.volume+3
	ldx #offset.v4
	jmp channel

channel	and #15
	tay
	lda field_buffer,x
	cmp height3,y
	bcc higher
	lda height3,y
	bcs store
higher	cmp #field_max_height-1
	bcs store
	adc #1
store	sta field_buffer,x

	set_line $00
	set_line $01 
	set_line $02 1
	set_line $03 1
	set_line $04 
	set_line $05
	rts

height3	.byte 31,29,27,25,23,21,19,17,15,13,11,9,7,5,3,1
	.endp	;move
	.endp	;vumeter

;===============================================================
	.proc scroll
	
	pixel_color0	= field_max_height-1
	pixel_color1	= 10

	.var char_buffer 	:8 .byte = field_vars	;8 lines
	.var pixel_count	.byte = char_buffer+9
	.var scrolling		.byte = pixel_count+1

	.if scrolling > field_vars_end
	.error "scrolling_mode > field_vars_end (", scrolling,, " > ",field_vars_end,")"
	.endif
	
	.get "field/Silly-Field-Mirror.bin"	;for static offsets

	.macro set_pixel
	lda #pixel_color0
	asl char_buffer+:1
	bcc black
	lda #pixel_color1
black	sta field_berg+:2	;Store original
	sta field_berg+$100+.get[:2]
	sta field_berg+$200+.get[:2+$100]
	sta field_berg+$300+.get[:2+$200]
	.endm

	.macro move_pixel
	lda field_berg+:1-1	;Load original
	sta field_berg+:1	;Store original
	sta field_berg+$100+.get[:1]
	sta field_berg+$200+.get[:1+$100]
	sta field_berg+$300+.get[:1+$200]
	.endm
	
	.macro move_line
	offset = 4
	move_pixel (:1+offset)*$10+$0f
	move_pixel (:1+offset)*$10+$0e
	move_pixel (:1+offset)*$10+$0d
	move_pixel (:1+offset)*$10+$0c
	move_pixel (:1+offset)*$10+$0b
	move_pixel (:1+offset)*$10+$0a
	move_pixel (:1+offset)*$10+$09
	move_pixel (:1+offset)*$10+$08
	move_pixel (:1+offset)*$10+$07
	move_pixel (:1+offset)*$10+$06
	move_pixel (:1+offset)*$10+$05
	move_pixel (:1+offset)*$10+$04
	move_pixel (:1+offset)*$10+$03
	move_pixel (:1+offset)*$10+$02
	move_pixel (:1+offset)*$10+$01
	set_pixel :1 (:1+offset)*$10+$00
	.endm

	.proc init
	jsr effect.init
	
	mwa #move.text move.text_adr
	mva #1 scrolling
	
	mva #points.plot.mask.four points.plot.plot_mask
	rts
	.endp

	.proc move
	move_line $00
	move_line $01 
	move_line $02
	intro.loading.bar.next
	move_line $03
	move_line $04 
	move_line $05
	intro.loading.bar.next
	move_line $06
	move_line $07
	intro.loading.bar.next

	lda scrolling
	beq no_scrolling
	dec pixel_count
	bpl no_char
	mva #field_chr_width pixel_count
wrap	lda $ffff
text_adr = *-2
	bpl no_warp
	inw text_adr
	lda #0
	sta scrolling
	beq no_scrolling

no_warp	inw text_adr
	sta p1
	lda #0
	asl p1
	rol
	asl p1
	rol
	asl p1
	rol
	clc
	adc #>field_chr
	sta p1+1
	ldy #7
copy_char
	lda (p1),y
	sta char_buffer,y
	dey
	bpl copy_char
no_char
no_scrolling
	rts


	
text	.byte "JAC! PRESENTS SILLY THINGS   ",$ff
	.byte "A DEMO FOR SILLY VENTURE 2010   ",$ff
	.byte "  GREETINGS TO:  ALTAIR - BLOWJOBB - FOX - HEAVEN - LA RESISTANCE - MAPA - MYSTIC BYTES - PG - RASTER - TITAN - XXL   ", $ff
	.byte "  THANKS TO: RYBAGS - TEZZ - TEBE ... AND MY FAMILY FOR THEIR SUPPORT   ", $ff

	.endp	;move
	.endp	;scroll

	.endp	;effect

;===============================================================
	.proc points

smup	 	= points_zp	;Screen up (1 byte)
frame_up	= points_zp+1	;Frame up (1 byte)
frame_number	= points_zp+2	;Frame number, lower 5 bite of frame_up (1 byte)
frame_step 	= points_zp+3	;Frame step (1 byte)

	.proc init

	clear_memory field_sm1, $1600	;Clear screen 1, note that offset $1520-$15ff is overwritten below
	clear_memory field_sm2, $1600	;Clear screen 2, note that offset $1520-$15ff is overwritten below

	jsr init_tabs
	jsr init_dl
	
	ldx #(.len zp)-1	;Copy zero page code
copy_zero_page
	lda zp0,x
	sta zp,x
	dex
	bpl copy_zero_page

	lda #0			;Reset field start frame.
	sta frame_up
	sta frame_number
	sta frame_step

	lda #1			;Init DL/SM pointer
	sta smup
	jmp swap


	.proc init_tabs
	mwa #field_sm1 p1
	ldx #0
tabs	cpx #[field_lines+1]
	bcs skip_field_llohi
	lda p1			;Genenerate field_llo, field_lhi1, field_lhi2
	sta field_llo,x
	lda p1+1
	sta field_lhi1,x
	clc
	adc #>[field_sm2-field_sm1]
	sta field_lhi2,x
	cpx #[field_lines-1]	;There is one more line for height $20 with color 0
	bcs skip_field_llohi	;and the same memory address as the one before
	adw p1 #32
skip_field_llohi

	lda #<[field_sm1+16]	;Preset clear adresses
	sta field_oldlo1,x
	sta field_oldlo2,x
	lda #>[field_sm1+16]
	sta field_oldhi1,x
	sta field_oldhi2,x

	txa
	and #3			;Pixel offset
	tay
	lda #0			;Field color 0, all zeros
	sta field_ctab0,x
	lda pixtab1,y		;Field color 1
	sta field_ctab1,x
	lda pixtab2,y		;Field color 2
	sta field_ctab2,x
	lda pixtab3,y		;Field color 3
	sta field_ctab3,x
	txa
	lsr
	lsr
	sta field_otab,x	;X offset table

	cpx #[field_max_height+1] 	;High bytes of the color table for height [0..field_max_height].
	bcs skip_field_ctab_hi
	lda #>field_ctab3
	cpx #12
	bcc *+4
	lda #>field_ctab2
	cpx #24
	bcc *+4
	lda #>field_ctab1
	cpx #field_max_height
	bcc *+4
	lda #>field_ctab0
	sta field_ctab_hi,x
skip_field_ctab_hi

	txa			;Comupute mirror offsets
	eor #$ff
	sta field_mirror+$100,x
	
	lda #0
	sta x1
	txa
	asl
	rol x1
	asl
	rol x1
	asl
	rol x1
	asl
	rol x1
	ora x1
	eor #$0f
	sta field_mirror+$200,x
	eor #$ff
	sta field_mirror+$000,x

	lda #field_max_height	;Maximum heigh means color 0
	sta field_berg,x
	sta field_berg+$100,x
	sta field_berg+$200,x
	sta field_berg+$300,x
	inx
	jne tabs
	rts

pixtab1	.byte $40,$10,$04,$01
pixtab2	.byte $80,$20,$08,$02
pixtab3	.byte $c0,$30,$0c,$03
	.endp	;init tabs

;===============================================================
;	The DL for the field would normally be 64+128=192 lines high.
;	The the lower 23 lines are not used and left blank to save DMA time.
;	This leaves 169 lines of visible display using
;	only $1520 of the $1800 byte of screen memory are used.
;	The DL takes $b0 bytes, the folloing routine oly $2c bytes.
;	Therefore it is worth while.

	.proc init_dl

dc	= $0e

;	.local dl
;	.byte $40+dc
;lms1	.word field_sm1
;	.rept 63
;	.byte dc
;	.endr
;
;	.byte $40+dc
;lms2	.word field_sm1+$800
;	.rept 127-23
;	.byte dc
;	.endr
;	.byte $41
;	.word silly_dl
;	.endl

	ldx #0
	lda #dc
loop	sta field_dl,x
	inx
	cpx #$b0
	bne loop
	ora #$40
	sta field_dl_lms1
	sta field_dl_lms2
	lda #0			;Set low byte to zero, high byte will be set by "swap"
	sta field_dl_lms1+1
	sta field_dl_lms2+1
	mva #$41 field_dl+$ad
	mwa #silly_dl field_dl+$ae
	rts

	.endp	;init_dl

	.endp	;init

;===============================================================

	.proc draw
	lda drawing
	beq not_drawing
	jsr swap
	jsr clear
	jsr plot
	jsr move
not_drawing
	rts
	.endp

drawing	.byte 0

;===============================================================
; Swap the two screens in the DL
	.proc swap
	lda smup
	eor #1
	sta smup
	beq swap1		;0 means screen 2
	lda #>field_sm1	
	.byte $2c		;BIT skip
swap1	lda #>field_sm2
	sta field_dl_lms1+2	;Upper DL part
	clc
	adc #$08		;8 pages until lower DL part
	sta field_dl_lms2+2
	rts
	.endp

;===============================================================
; All clears must have been completed before the next plot
; Otherwise new plot might get erased again

	.proc clear
	ldy #>field_oldlo1	;Determine address buffers
	lda smup
	beq clear1
	ldy #>field_oldlo2
clear1

	.if .def fast_mix	;Optimized remix code
 	sty zp.clear.zplo1+2	;Set buffer for low addresses
 	sty zp.clear.zplo2+2
	iny
	sty zp.clear.zphi1+2	;High addresses are on the next page
	sty zp.clear.zphi2+2
	.else			;Original code
 	sty zp.clear.zp2+2	;Set buffer for low addresses
	iny
	sty zp.clear.zp1+2	;High addresses are on the next page
	.endif

	lda #0
	tax
	jmp zp.clear
	.endp

;===============================================================

	.proc plot

	.enum mask
		one = $00
		four = $60
	.ende
	
	ldx #>field_lhi1	;Set screen base
	ldy #>field_oldlo1
	lda smup
	beq plot1
	ldx #>field_lhi2
	ldy #>field_oldlo2
plot1	stx zp.plot.zp3+2	;Set field_lhi1/2
	sty zp.plot.zp8+2	;Set field_oldlo1/2
	iny
	sty zp.plot.zp4+2	;Set field_oldhi1/2

	lda frame_up		;Low bits count the frame.
	and #31			;0..31
	sta frame_number	;Store only for use in synchronization
	asl			;C=0
	adc #>field_data
	sta zp.plot.zp6+2	;X-positions
	adc #1			;C=0, next page
	sta zp.plot.zp2+2	;Y-positions

	lda frame_up		;High bits count the field_berg
	and #mask.four		;$00..$60
plot_mask = *-1
	lsr			;$00..$30
	lsr			;$00..$18
	lsr			;$00..$0c
	lsr			;$00..$06
	lsr			;$00..$03
	adc #>field_berg	;C=0
	sta zp.plot.zp1+2	;Set high byte of field_berg

	ldx #0			;C=0
	jmp zp.plot
	.endp

;===============================================================
	.proc move
	clc
	lda frame_up		;Next_frame.
	adc frame_step		;Add/Sub step width.
	sta frame_up
	rts
	.endp			;End of move

;===============================================================
;	>> P-Zero-Code <<
;===============================================================

zp0	org code_zp, *		;So it ends at $00bf

	.proc zp

;===============================================================
;	Assumes A=X=0, high bytes of old low and high tables have
;	been set to [zphi1+2]/[zphi2+2] and [zplo1+2]/[zplo2+2].
;	This is the optimized version which saves (2+3)*128 = 640 cycles 
;===============================================================

	.proc clear
	
	.if .def fast_mix	;Optimized remix code
zp1
zphi1	ldy field_oldhi1,x	;Get high byte
	sty zpadr1+2
zplo1	ldy field_oldlo1,x	;Get low byte
zpadr1	sta $ff00,y		;Clear byte

zphi2	ldy field_oldhi1+$80,x	;Get high byte
	sty zpadr2+2
zplo2	ldy field_oldlo1+$80,x	;Get low byte
zpadr2	sta $ff00,y		;Clear byte

	inx			;Next byte
	bpl zp1
	rts

	.else			;Original code
zp1	ldy field_oldhi1,x	;Get high byte
	sty zp3+2
zp2	ldy field_oldlo1,x	;Get low byte
zp3	sta $ff00,y		;Clear byte
	inx			;Next byte
	bne zp1
	rts
	.endif
	.endp			;clear

;===============================================================
;	Assumes X=0, C=0, high bytes of old low and high tables
;	have been set to all labels marked below
;===============================================================

	.proc plot
zp1	ldy field_berg,x
	lda field_ctab_hi,y	;
	sta zp9+2
	tya
zp2	adc field_data+$100,x	;Field y table page
	tay			;must never be >field_lines+1
zp3	lda field_lhi1,y	;Y position address, hight byte
	sta zpp+2		;Store high byte in pointer
zp4	sta field_oldhi1,x	;Store hight byte in history
	lda field_llo,y		;Y position address, low byte
zp6	ldy field_data,x	;Field x table page
	adc field_otab,y	;X position (byte)
	sta zpp+1		;Store low byte in pointer
zp8	sta field_oldlo1,x	;Store low byte in history
zp9	lda field_ctab1,y	;X position pixel
	ldy #0
zpp	ora $ffff		;ORA (P1)
	sta (zpp+1),y		;STA (P1),y

	inx			;Next_Point
	bne zp1
	rts
zp_end
	.if zp_end>$c0
		.error "Zero page limit exceeded at ", zp_end
	.endif 
	.endp			;plot

;===============================================================

	.endp			;zp

	org zp0 + .len zp	;Set origin to original start plus length of zp

	.endp			;points

;===============================================================

	.proc dli
	lda #$21		;Small playfield
	sta dmactl
	lda #silly_prior
	sta prior

	txa
	pha
	tya
	pha
	jsr points.draw
	jmp nmi.main_nmi_end
	.endp			;End of dli
	